import $, { createContext as gt, useContext as ut, useState as k, useEffect as Ce, memo as Pe, forwardRef as re, useCallback as Ne, useMemo as qe } from "react";
import { jsx as a, jsxs as v, Fragment as Re } from "react/jsx-runtime";
import { Tooltip as _t, EmptyState as ne, EmptyStateVariant as pt, EmptyStateHeader as oe, EmptyStateBody as me, Spinner as ee, Alert as ft, Dropdown as mt, MenuToggle as Je, DropdownList as wt, Divider as Ke, DropdownItem as vt, Select as St, SelectOption as yt, TextInput as ae, Button as ce, TextArea as bt, AboutModal as kt, TextContent as Tt, Text as De, TextVariants as Le, TextList as je, TextListItem as b, Modal as Ue, Form as Be, FormGroup as He, Progress as It, EmptyStateIcon as ze, ChipGroup as Et, Chip as Ct, InputGroup as Pt, ButtonVariant as Rt, Pagination as Ut, PaginationVariant as xt, Skeleton as At } from "@patternfly/react-core";
import { EllipsisVIcon as Ot, ChevronDownIcon as Nt, ChevronRightIcon as qt, ErrorCircleOIcon as Dt, SearchIcon as Lt } from "@patternfly/react-icons";
import { DateTime as se } from "luxon";
import { Tr as le, Td as xe, Th as jt, Table as Ht, Thead as $t, Tbody as Mt, ActionsColumn as Ft } from "@patternfly/react-table";
import Wt from "use-resize-observer";
const Jt = gt({
  type: "none"
});
class Y extends Error {
}
Y.prototype.name = "InvalidTokenError";
function Kt(e) {
  return decodeURIComponent(atob(e).replace(/(.)/g, (t, s) => {
    let i = s.charCodeAt(0).toString(16).toUpperCase();
    return i.length < 2 && (i = "0" + i), "%" + i;
  }));
}
function Bt(e) {
  let t = e.replace(/-/g, "+").replace(/_/g, "/");
  switch (t.length % 4) {
    case 0:
      break;
    case 2:
      t += "==";
      break;
    case 3:
      t += "=";
      break;
    default:
      throw new Error("base64 string is not of the correct length");
  }
  try {
    return Kt(t);
  } catch {
    return atob(t);
  }
}
function zt(e, t) {
  if (typeof e != "string")
    throw new Y("Invalid token specified: must be a string");
  t || (t = {});
  const s = t.header === !0 ? 0 : 1, i = e.split(".")[s];
  if (typeof i != "string")
    throw new Y(`Invalid token specified: missing part #${s + 1}`);
  let r;
  try {
    r = Bt(i);
  } catch (n) {
    throw new Y(`Invalid token specified: invalid base64 for part #${s + 1} (${n.message})`);
  }
  try {
    return JSON.parse(r);
  } catch (n) {
    throw new Y(`Invalid token specified: invalid json for part #${s + 1} (${n.message})`);
  }
}
var Vt = {
  debug: () => {
  },
  info: () => {
  },
  warn: () => {
  },
  error: () => {
  }
}, j, H, de = /* @__PURE__ */ ((e) => (e[e.NONE = 0] = "NONE", e[e.ERROR = 1] = "ERROR", e[e.WARN = 2] = "WARN", e[e.INFO = 3] = "INFO", e[e.DEBUG = 4] = "DEBUG", e))(de || {});
((e) => {
  function t() {
    j = 3, H = Vt;
  }
  e.reset = t;
  function s(r) {
    if (!(0 <= r && r <= 4))
      throw new Error("Invalid log level");
    j = r;
  }
  e.setLevel = s;
  function i(r) {
    H = r;
  }
  e.setLogger = i;
})(de || (de = {}));
var u = class D {
  constructor(t) {
    this._name = t;
  }
  /* eslint-disable @typescript-eslint/no-unsafe-enum-comparison */
  debug(...t) {
    j >= 4 && H.debug(D._format(this._name, this._method), ...t);
  }
  info(...t) {
    j >= 3 && H.info(D._format(this._name, this._method), ...t);
  }
  warn(...t) {
    j >= 2 && H.warn(D._format(this._name, this._method), ...t);
  }
  error(...t) {
    j >= 1 && H.error(D._format(this._name, this._method), ...t);
  }
  /* eslint-enable @typescript-eslint/no-unsafe-enum-comparison */
  throw(t) {
    throw this.error(t), t;
  }
  create(t) {
    const s = Object.create(this);
    return s._method = t, s.debug("begin"), s;
  }
  static createStatic(t, s) {
    const i = new D(`${t}.${s}`);
    return i.debug("begin"), i;
  }
  static _format(t, s) {
    const i = `[${t}]`;
    return s ? `${i} ${s}:` : i;
  }
  /* eslint-disable @typescript-eslint/no-unsafe-enum-comparison */
  // helpers for static class methods
  static debug(t, ...s) {
    j >= 4 && H.debug(D._format(t), ...s);
  }
  static info(t, ...s) {
    j >= 3 && H.info(D._format(t), ...s);
  }
  static warn(t, ...s) {
    j >= 2 && H.warn(D._format(t), ...s);
  }
  static error(t, ...s) {
    j >= 1 && H.error(D._format(t), ...s);
  }
  /* eslint-enable @typescript-eslint/no-unsafe-enum-comparison */
};
de.reset();
var he = class {
  // IMPORTANT: doesn't validate the token
  static decode(e) {
    try {
      return zt(e);
    } catch (t) {
      throw u.error("JwtUtils.decode", t), t;
    }
  }
  static async generateSignedJwt(e, t, s) {
    const i = C.encodeBase64Url(new TextEncoder().encode(JSON.stringify(e))), r = C.encodeBase64Url(new TextEncoder().encode(JSON.stringify(t))), n = `${i}.${r}`, o = await window.crypto.subtle.sign(
      {
        name: "ECDSA",
        hash: { name: "SHA-256" }
      },
      s,
      new TextEncoder().encode(n)
    ), c = C.encodeBase64Url(new Uint8Array(o));
    return `${n}.${c}`;
  }
}, Gt = "10000000-1000-4000-8000-100000000000", we = (e) => btoa([...new Uint8Array(e)].map((t) => String.fromCharCode(t)).join("")), Ve = class L {
  static _randomWord() {
    const t = new Uint32Array(1);
    return crypto.getRandomValues(t), t[0];
  }
  /**
   * Generates RFC4122 version 4 guid
   */
  static generateUUIDv4() {
    return Gt.replace(
      /[018]/g,
      (s) => (+s ^ L._randomWord() & 15 >> +s / 4).toString(16)
    ).replace(/-/g, "");
  }
  /**
   * PKCE: Generate a code verifier
   */
  static generateCodeVerifier() {
    return L.generateUUIDv4() + L.generateUUIDv4() + L.generateUUIDv4();
  }
  /**
   * PKCE: Generate a code challenge
   */
  static async generateCodeChallenge(t) {
    if (!crypto.subtle)
      throw new Error("Crypto.subtle is available only in secure contexts (HTTPS).");
    try {
      const i = new TextEncoder().encode(t), r = await crypto.subtle.digest("SHA-256", i);
      return we(r).replace(/\+/g, "-").replace(/\//g, "_").replace(/=+$/, "");
    } catch (s) {
      throw u.error("CryptoUtils.generateCodeChallenge", s), s;
    }
  }
  /**
   * Generates a base64-encoded string for a basic auth header
   */
  static generateBasicAuth(t, s) {
    const r = new TextEncoder().encode([t, s].join(":"));
    return we(r);
  }
  /**
   * Generates a hash of a string using a given algorithm
   * @param alg
   * @param message
   */
  static async hash(t, s) {
    const i = new TextEncoder().encode(s), r = await crypto.subtle.digest(t, i);
    return new Uint8Array(r);
  }
  /**
   * Generates a rfc7638 compliant jwk thumbprint
   * @param jwk
   */
  static async customCalculateJwkThumbprint(t) {
    let s;
    switch (t.kty) {
      case "RSA":
        s = {
          e: t.e,
          kty: t.kty,
          n: t.n
        };
        break;
      case "EC":
        s = {
          crv: t.crv,
          kty: t.kty,
          x: t.x,
          y: t.y
        };
        break;
      case "OKP":
        s = {
          crv: t.crv,
          kty: t.kty,
          x: t.x
        };
        break;
      case "oct":
        s = {
          crv: t.k,
          kty: t.kty
        };
        break;
      default:
        throw new Error("Unknown jwk type");
    }
    const i = await L.hash("SHA-256", JSON.stringify(s));
    return L.encodeBase64Url(i);
  }
  static async generateDPoPProof({
    url: t,
    accessToken: s,
    httpMethod: i,
    keyPair: r,
    nonce: n
  }) {
    let o, c;
    const l = {
      jti: window.crypto.randomUUID(),
      htm: i ?? "GET",
      htu: t,
      iat: Math.floor(Date.now() / 1e3)
    };
    s && (o = await L.hash("SHA-256", s), c = L.encodeBase64Url(o), l.ath = c), n && (l.nonce = n);
    try {
      const d = await crypto.subtle.exportKey("jwk", r.publicKey), h = {
        alg: "ES256",
        typ: "dpop+jwt",
        jwk: {
          crv: d.crv,
          kty: d.kty,
          x: d.x,
          y: d.y
        }
      };
      return await he.generateSignedJwt(h, l, r.privateKey);
    } catch (d) {
      throw d instanceof TypeError ? new Error(`Error exporting dpop public key: ${d.message}`) : d;
    }
  }
  static async generateDPoPJkt(t) {
    try {
      const s = await crypto.subtle.exportKey("jwk", t.publicKey);
      return await L.customCalculateJwkThumbprint(s);
    } catch (s) {
      throw s instanceof TypeError ? new Error(`Could not retrieve dpop keys from storage: ${s.message}`) : s;
    }
  }
  static async generateDPoPKeys() {
    return await window.crypto.subtle.generateKey(
      {
        name: "ECDSA",
        namedCurve: "P-256"
      },
      !1,
      ["sign", "verify"]
    );
  }
};
Ve.encodeBase64Url = (e) => we(e).replace(/=/g, "").replace(/\+/g, "-").replace(/\//g, "_");
var C = Ve, W = class {
  constructor(e) {
    this._name = e, this._callbacks = [], this._logger = new u(`Event('${this._name}')`);
  }
  addHandler(e) {
    return this._callbacks.push(e), () => this.removeHandler(e);
  }
  removeHandler(e) {
    const t = this._callbacks.lastIndexOf(e);
    t >= 0 && this._callbacks.splice(t, 1);
  }
  async raise(...e) {
    this._logger.debug("raise:", ...e);
    for (const t of this._callbacks)
      await t(...e);
  }
}, $e = class {
  /**
   * Populates a map of window features with a placement centered in front of
   * the current window. If no explicit width is given, a default value is
   * binned into [800, 720, 600, 480, 360] based on the current window's width.
   */
  static center({ ...e }) {
    var t, s, i;
    return e.width == null && (e.width = (t = [800, 720, 600, 480].find((r) => r <= window.outerWidth / 1.618)) != null ? t : 360), (s = e.left) != null || (e.left = Math.max(0, Math.round(window.screenX + (window.outerWidth - e.width) / 2))), e.height != null && ((i = e.top) != null || (e.top = Math.max(0, Math.round(window.screenY + (window.outerHeight - e.height) / 2)))), e;
  }
  static serialize(e) {
    return Object.entries(e).filter(([, t]) => t != null).map(([t, s]) => `${t}=${typeof s != "boolean" ? s : s ? "yes" : "no"}`).join(",");
  }
}, F = class ie extends W {
  constructor() {
    super(...arguments), this._logger = new u(`Timer('${this._name}')`), this._timerHandle = null, this._expiration = 0, this._callback = () => {
      const t = this._expiration - ie.getEpochTime();
      this._logger.debug("timer completes in", t), this._expiration <= ie.getEpochTime() && (this.cancel(), super.raise());
    };
  }
  // get the time
  static getEpochTime() {
    return Math.floor(Date.now() / 1e3);
  }
  init(t) {
    const s = this._logger.create("init");
    t = Math.max(Math.floor(t), 1);
    const i = ie.getEpochTime() + t;
    if (this.expiration === i && this._timerHandle) {
      s.debug("skipping since already initialized for expiration at", this.expiration);
      return;
    }
    this.cancel(), s.debug("using duration", t), this._expiration = i;
    const r = Math.min(t, 5);
    this._timerHandle = setInterval(this._callback, r * 1e3);
  }
  get expiration() {
    return this._expiration;
  }
  cancel() {
    this._logger.create("cancel"), this._timerHandle && (clearInterval(this._timerHandle), this._timerHandle = null);
  }
}, ve = class {
  static readParams(e, t = "query") {
    if (!e) throw new TypeError("Invalid URL");
    const i = new URL(e, "http://127.0.0.1")[t === "fragment" ? "hash" : "search"];
    return new URLSearchParams(i.slice(1));
  }
}, Se = ";", B = class extends Error {
  constructor(e, t) {
    var s, i, r;
    if (super(e.error_description || e.error || ""), this.form = t, this.name = "ErrorResponse", !e.error)
      throw u.error("ErrorResponse", "No error passed"), new Error("No error passed");
    this.error = e.error, this.error_description = (s = e.error_description) != null ? s : null, this.error_uri = (i = e.error_uri) != null ? i : null, this.state = e.userState, this.session_state = (r = e.session_state) != null ? r : null, this.url_state = e.url_state;
  }
}, Ae = class extends Error {
  constructor(e) {
    super(e), this.name = "ErrorTimeout";
  }
}, Qt = class {
  constructor(e) {
    this._logger = new u("AccessTokenEvents"), this._expiringTimer = new F("Access token expiring"), this._expiredTimer = new F("Access token expired"), this._expiringNotificationTimeInSeconds = e.expiringNotificationTimeInSeconds;
  }
  load(e) {
    const t = this._logger.create("load");
    if (e.access_token && e.expires_in !== void 0) {
      const s = e.expires_in;
      if (t.debug("access token present, remaining duration:", s), s > 0) {
        let r = s - this._expiringNotificationTimeInSeconds;
        r <= 0 && (r = 1), t.debug("registering expiring timer, raising in", r, "seconds"), this._expiringTimer.init(r);
      } else
        t.debug("canceling existing expiring timer because we're past expiration."), this._expiringTimer.cancel();
      const i = s + 1;
      t.debug("registering expired timer, raising in", i, "seconds"), this._expiredTimer.init(i);
    } else
      this._expiringTimer.cancel(), this._expiredTimer.cancel();
  }
  unload() {
    this._logger.debug("unload: canceling existing access token timers"), this._expiringTimer.cancel(), this._expiredTimer.cancel();
  }
  /**
   * Add callback: Raised prior to the access token expiring.
   */
  addAccessTokenExpiring(e) {
    return this._expiringTimer.addHandler(e);
  }
  /**
   * Remove callback: Raised prior to the access token expiring.
   */
  removeAccessTokenExpiring(e) {
    this._expiringTimer.removeHandler(e);
  }
  /**
   * Add callback: Raised after the access token has expired.
   */
  addAccessTokenExpired(e) {
    return this._expiredTimer.addHandler(e);
  }
  /**
   * Remove callback: Raised after the access token has expired.
   */
  removeAccessTokenExpired(e) {
    this._expiredTimer.removeHandler(e);
  }
}, Xt = class {
  constructor(e, t, s, i, r) {
    this._callback = e, this._client_id = t, this._intervalInSeconds = i, this._stopOnError = r, this._logger = new u("CheckSessionIFrame"), this._timer = null, this._session_state = null, this._message = (o) => {
      o.origin === this._frame_origin && o.source === this._frame.contentWindow && (o.data === "error" ? (this._logger.error("error message from check session op iframe"), this._stopOnError && this.stop()) : o.data === "changed" ? (this._logger.debug("changed message from check session op iframe"), this.stop(), this._callback()) : this._logger.debug(o.data + " message from check session op iframe"));
    };
    const n = new URL(s);
    this._frame_origin = n.origin, this._frame = window.document.createElement("iframe"), this._frame.style.visibility = "hidden", this._frame.style.position = "fixed", this._frame.style.left = "-1000px", this._frame.style.top = "0", this._frame.width = "0", this._frame.height = "0", this._frame.src = n.href;
  }
  load() {
    return new Promise((e) => {
      this._frame.onload = () => {
        e();
      }, window.document.body.appendChild(this._frame), window.addEventListener("message", this._message, !1);
    });
  }
  start(e) {
    if (this._session_state === e)
      return;
    this._logger.create("start"), this.stop(), this._session_state = e;
    const t = () => {
      !this._frame.contentWindow || !this._session_state || this._frame.contentWindow.postMessage(this._client_id + " " + this._session_state, this._frame_origin);
    };
    t(), this._timer = setInterval(t, this._intervalInSeconds * 1e3);
  }
  stop() {
    this._logger.create("stop"), this._session_state = null, this._timer && (clearInterval(this._timer), this._timer = null);
  }
}, Ge = class {
  constructor() {
    this._logger = new u("InMemoryWebStorage"), this._data = {};
  }
  clear() {
    this._logger.create("clear"), this._data = {};
  }
  getItem(e) {
    return this._logger.create(`getItem('${e}')`), this._data[e];
  }
  setItem(e, t) {
    this._logger.create(`setItem('${e}')`), this._data[e] = t;
  }
  removeItem(e) {
    this._logger.create(`removeItem('${e}')`), delete this._data[e];
  }
  get length() {
    return Object.getOwnPropertyNames(this._data).length;
  }
  key(e) {
    return Object.getOwnPropertyNames(this._data)[e];
  }
}, ye = class extends Error {
  constructor(e, t) {
    super(t), this.name = "ErrorDPoPNonce", this.nonce = e;
  }
}, Oe = class {
  constructor(e = [], t = null, s = {}) {
    this._jwtHandler = t, this._extraHeaders = s, this._logger = new u("JsonService"), this._contentTypes = [], this._contentTypes.push(...e, "application/json"), t && this._contentTypes.push("application/jwt");
  }
  async fetchWithTimeout(e, t = {}) {
    const { timeoutInSeconds: s, ...i } = t;
    if (!s)
      return await fetch(e, i);
    const r = new AbortController(), n = setTimeout(() => r.abort(), s * 1e3);
    try {
      return await fetch(e, {
        ...t,
        signal: r.signal
      });
    } catch (o) {
      throw o instanceof DOMException && o.name === "AbortError" ? new Ae("Network timed out") : o;
    } finally {
      clearTimeout(n);
    }
  }
  async getJson(e, {
    token: t,
    credentials: s,
    timeoutInSeconds: i
  } = {}) {
    const r = this._logger.create("getJson"), n = {
      Accept: this._contentTypes.join(", ")
    };
    t && (r.debug("token passed, setting Authorization header"), n.Authorization = "Bearer " + t), this.appendExtraHeaders(n);
    let o;
    try {
      r.debug("url:", e), o = await this.fetchWithTimeout(e, { method: "GET", headers: n, timeoutInSeconds: i, credentials: s });
    } catch (d) {
      throw r.error("Network Error"), d;
    }
    r.debug("HTTP response received, status", o.status);
    const c = o.headers.get("Content-Type");
    if (c && !this._contentTypes.find((d) => c.startsWith(d)) && r.throw(new Error(`Invalid response Content-Type: ${c ?? "undefined"}, from URL: ${e}`)), o.ok && this._jwtHandler && (c != null && c.startsWith("application/jwt")))
      return await this._jwtHandler(await o.text());
    let l;
    try {
      l = await o.json();
    } catch (d) {
      throw r.error("Error parsing JSON response", d), o.ok ? d : new Error(`${o.statusText} (${o.status})`);
    }
    if (!o.ok)
      throw r.error("Error from server:", l), l.error ? new B(l) : new Error(`${o.statusText} (${o.status}): ${JSON.stringify(l)}`);
    return l;
  }
  async postForm(e, {
    body: t,
    basicAuth: s,
    timeoutInSeconds: i,
    initCredentials: r,
    extraHeaders: n
  }) {
    const o = this._logger.create("postForm"), c = {
      Accept: this._contentTypes.join(", "),
      "Content-Type": "application/x-www-form-urlencoded",
      ...n
    };
    s !== void 0 && (c.Authorization = "Basic " + s), this.appendExtraHeaders(c);
    let l;
    try {
      o.debug("url:", e), l = await this.fetchWithTimeout(e, { method: "POST", headers: c, body: t, timeoutInSeconds: i, credentials: r });
    } catch (_) {
      throw o.error("Network error"), _;
    }
    o.debug("HTTP response received, status", l.status);
    const d = l.headers.get("Content-Type");
    if (d && !this._contentTypes.find((_) => d.startsWith(_)))
      throw new Error(`Invalid response Content-Type: ${d ?? "undefined"}, from URL: ${e}`);
    const h = await l.text();
    let g = {};
    if (h)
      try {
        g = JSON.parse(h);
      } catch (_) {
        throw o.error("Error parsing JSON response", _), l.ok ? _ : new Error(`${l.statusText} (${l.status})`);
      }
    if (!l.ok) {
      if (o.error("Error from server:", g), l.headers.has("dpop-nonce")) {
        const _ = l.headers.get("dpop-nonce");
        throw new ye(_, `${JSON.stringify(g)}`);
      }
      throw g.error ? new B(g, t) : new Error(`${l.statusText} (${l.status}): ${JSON.stringify(g)}`);
    }
    return g;
  }
  appendExtraHeaders(e) {
    const t = this._logger.create("appendExtraHeaders"), s = Object.keys(this._extraHeaders), i = [
      "authorization",
      "accept",
      "content-type"
    ];
    s.length !== 0 && s.forEach((r) => {
      if (i.includes(r.toLocaleLowerCase())) {
        t.warn("Protected header could not be overridden", r, i);
        return;
      }
      const n = typeof this._extraHeaders[r] == "function" ? this._extraHeaders[r]() : this._extraHeaders[r];
      n && n !== "" && (e[r] = n);
    });
  }
}, Yt = class {
  constructor(e) {
    this._settings = e, this._logger = new u("MetadataService"), this._signingKeys = null, this._metadata = null, this._metadataUrl = this._settings.metadataUrl, this._jsonService = new Oe(
      ["application/jwk-set+json"],
      null,
      this._settings.extraHeaders
    ), this._settings.signingKeys && (this._logger.debug("using signingKeys from settings"), this._signingKeys = this._settings.signingKeys), this._settings.metadata && (this._logger.debug("using metadata from settings"), this._metadata = this._settings.metadata), this._settings.fetchRequestCredentials && (this._logger.debug("using fetchRequestCredentials from settings"), this._fetchRequestCredentials = this._settings.fetchRequestCredentials);
  }
  resetSigningKeys() {
    this._signingKeys = null;
  }
  async getMetadata() {
    const e = this._logger.create("getMetadata");
    if (this._metadata)
      return e.debug("using cached values"), this._metadata;
    if (!this._metadataUrl)
      throw e.throw(new Error("No authority or metadataUrl configured on settings")), null;
    e.debug("getting metadata from", this._metadataUrl);
    const t = await this._jsonService.getJson(this._metadataUrl, { credentials: this._fetchRequestCredentials, timeoutInSeconds: this._settings.requestTimeoutInSeconds });
    return e.debug("merging remote JSON with seed metadata"), this._metadata = Object.assign({}, this._settings.metadataSeed, t), this._metadata;
  }
  getIssuer() {
    return this._getMetadataProperty("issuer");
  }
  getAuthorizationEndpoint() {
    return this._getMetadataProperty("authorization_endpoint");
  }
  getUserInfoEndpoint() {
    return this._getMetadataProperty("userinfo_endpoint");
  }
  getTokenEndpoint(e = !0) {
    return this._getMetadataProperty("token_endpoint", e);
  }
  getCheckSessionIframe() {
    return this._getMetadataProperty("check_session_iframe", !0);
  }
  getEndSessionEndpoint() {
    return this._getMetadataProperty("end_session_endpoint", !0);
  }
  getRevocationEndpoint(e = !0) {
    return this._getMetadataProperty("revocation_endpoint", e);
  }
  getKeysEndpoint(e = !0) {
    return this._getMetadataProperty("jwks_uri", e);
  }
  async _getMetadataProperty(e, t = !1) {
    const s = this._logger.create(`_getMetadataProperty('${e}')`), i = await this.getMetadata();
    if (s.debug("resolved"), i[e] === void 0) {
      if (t === !0) {
        s.warn("Metadata does not contain optional property");
        return;
      }
      s.throw(new Error("Metadata does not contain property " + e));
    }
    return i[e];
  }
  async getSigningKeys() {
    const e = this._logger.create("getSigningKeys");
    if (this._signingKeys)
      return e.debug("returning signingKeys from cache"), this._signingKeys;
    const t = await this.getKeysEndpoint(!1);
    e.debug("got jwks_uri", t);
    const s = await this._jsonService.getJson(t, { timeoutInSeconds: this._settings.requestTimeoutInSeconds });
    if (e.debug("got key set", s), !Array.isArray(s.keys))
      throw e.throw(new Error("Missing keys on keyset")), null;
    return this._signingKeys = s.keys, this._signingKeys;
  }
}, Qe = class {
  constructor({
    prefix: e = "oidc.",
    store: t = localStorage
  } = {}) {
    this._logger = new u("WebStorageStateStore"), this._store = t, this._prefix = e;
  }
  async set(e, t) {
    this._logger.create(`set('${e}')`), e = this._prefix + e, await this._store.setItem(e, t);
  }
  async get(e) {
    return this._logger.create(`get('${e}')`), e = this._prefix + e, await this._store.getItem(e);
  }
  async remove(e) {
    this._logger.create(`remove('${e}')`), e = this._prefix + e;
    const t = await this._store.getItem(e);
    return await this._store.removeItem(e), t;
  }
  async getAllKeys() {
    this._logger.create("getAllKeys");
    const e = await this._store.length, t = [];
    for (let s = 0; s < e; s++) {
      const i = await this._store.key(s);
      i && i.indexOf(this._prefix) === 0 && t.push(i.substr(this._prefix.length));
    }
    return t;
  }
}, Zt = "code", es = "openid", ts = "client_secret_post", ss = 60 * 15, be = class {
  constructor({
    // metadata related
    authority: e,
    metadataUrl: t,
    metadata: s,
    signingKeys: i,
    metadataSeed: r,
    // client related
    client_id: n,
    client_secret: o,
    response_type: c = Zt,
    scope: l = es,
    redirect_uri: d,
    post_logout_redirect_uri: h,
    client_authentication: g = ts,
    // optional protocol
    prompt: _,
    display: S,
    max_age: x,
    ui_locales: T,
    acr_values: A,
    resource: I,
    response_mode: N,
    // behavior flags
    filterProtocolClaims: P = !0,
    loadUserInfo: M = !1,
    requestTimeoutInSeconds: R,
    staleStateAgeInSeconds: m = ss,
    mergeClaimsStrategy: E = { array: "replace" },
    disablePKCE: U = !1,
    // other behavior
    stateStore: y,
    revokeTokenAdditionalContentTypes: z,
    fetchRequestCredentials: f,
    refreshTokenAllowedScope: w,
    // extra
    extraQueryParams: q = {},
    extraTokenParams: J = {},
    extraHeaders: K = {},
    dpop: Q,
    omitScopeWhenRequesting: _e = !1
  }) {
    var X;
    if (this.authority = e, t ? this.metadataUrl = t : (this.metadataUrl = e, e && (this.metadataUrl.endsWith("/") || (this.metadataUrl += "/"), this.metadataUrl += ".well-known/openid-configuration")), this.metadata = s, this.metadataSeed = r, this.signingKeys = i, this.client_id = n, this.client_secret = o, this.response_type = c, this.scope = l, this.redirect_uri = d, this.post_logout_redirect_uri = h, this.client_authentication = g, this.prompt = _, this.display = S, this.max_age = x, this.ui_locales = T, this.acr_values = A, this.resource = I, this.response_mode = N, this.filterProtocolClaims = P ?? !0, this.loadUserInfo = !!M, this.staleStateAgeInSeconds = m, this.mergeClaimsStrategy = E, this.omitScopeWhenRequesting = _e, this.disablePKCE = !!U, this.revokeTokenAdditionalContentTypes = z, this.fetchRequestCredentials = f || "same-origin", this.requestTimeoutInSeconds = R, y)
      this.stateStore = y;
    else {
      const te = typeof window < "u" ? window.localStorage : new Ge();
      this.stateStore = new Qe({ store: te });
    }
    if (this.refreshTokenAllowedScope = w, this.extraQueryParams = q, this.extraTokenParams = J, this.extraHeaders = K, this.dpop = Q, this.dpop && !((X = this.dpop) != null && X.store))
      throw new Error("A DPoPStore is required when dpop is enabled");
  }
}, is = class {
  constructor(e, t) {
    this._settings = e, this._metadataService = t, this._logger = new u("UserInfoService"), this._getClaimsFromJwt = async (s) => {
      const i = this._logger.create("_getClaimsFromJwt");
      try {
        const r = he.decode(s);
        return i.debug("JWT decoding successful"), r;
      } catch (r) {
        throw i.error("Error parsing JWT response"), r;
      }
    }, this._jsonService = new Oe(
      void 0,
      this._getClaimsFromJwt,
      this._settings.extraHeaders
    );
  }
  async getClaims(e) {
    const t = this._logger.create("getClaims");
    e || this._logger.throw(new Error("No token passed"));
    const s = await this._metadataService.getUserInfoEndpoint();
    t.debug("got userinfo url", s);
    const i = await this._jsonService.getJson(s, {
      token: e,
      credentials: this._settings.fetchRequestCredentials,
      timeoutInSeconds: this._settings.requestTimeoutInSeconds
    });
    return t.debug("got claims", i), i;
  }
}, Xe = class {
  constructor(e, t) {
    this._settings = e, this._metadataService = t, this._logger = new u("TokenClient"), this._jsonService = new Oe(
      this._settings.revokeTokenAdditionalContentTypes,
      null,
      this._settings.extraHeaders
    );
  }
  /**
   * Exchange code.
   *
   * @see https://www.rfc-editor.org/rfc/rfc6749#section-4.1.3
   */
  async exchangeCode({
    grant_type: e = "authorization_code",
    redirect_uri: t = this._settings.redirect_uri,
    client_id: s = this._settings.client_id,
    client_secret: i = this._settings.client_secret,
    extraHeaders: r,
    ...n
  }) {
    const o = this._logger.create("exchangeCode");
    s || o.throw(new Error("A client_id is required")), t || o.throw(new Error("A redirect_uri is required")), n.code || o.throw(new Error("A code is required"));
    const c = new URLSearchParams({ grant_type: e, redirect_uri: t });
    for (const [g, _] of Object.entries(n))
      _ != null && c.set(g, _);
    let l;
    switch (this._settings.client_authentication) {
      case "client_secret_basic":
        if (!i)
          throw o.throw(new Error("A client_secret is required")), null;
        l = C.generateBasicAuth(s, i);
        break;
      case "client_secret_post":
        c.append("client_id", s), i && c.append("client_secret", i);
        break;
    }
    const d = await this._metadataService.getTokenEndpoint(!1);
    o.debug("got token endpoint");
    const h = await this._jsonService.postForm(d, {
      body: c,
      basicAuth: l,
      timeoutInSeconds: this._settings.requestTimeoutInSeconds,
      initCredentials: this._settings.fetchRequestCredentials,
      extraHeaders: r
    });
    return o.debug("got response"), h;
  }
  /**
   * Exchange credentials.
   *
   * @see https://www.rfc-editor.org/rfc/rfc6749#section-4.3.2
   */
  async exchangeCredentials({
    grant_type: e = "password",
    client_id: t = this._settings.client_id,
    client_secret: s = this._settings.client_secret,
    scope: i = this._settings.scope,
    ...r
  }) {
    const n = this._logger.create("exchangeCredentials");
    t || n.throw(new Error("A client_id is required"));
    const o = new URLSearchParams({ grant_type: e });
    this._settings.omitScopeWhenRequesting || o.set("scope", i);
    for (const [h, g] of Object.entries(r))
      g != null && o.set(h, g);
    let c;
    switch (this._settings.client_authentication) {
      case "client_secret_basic":
        if (!s)
          throw n.throw(new Error("A client_secret is required")), null;
        c = C.generateBasicAuth(t, s);
        break;
      case "client_secret_post":
        o.append("client_id", t), s && o.append("client_secret", s);
        break;
    }
    const l = await this._metadataService.getTokenEndpoint(!1);
    n.debug("got token endpoint");
    const d = await this._jsonService.postForm(l, { body: o, basicAuth: c, timeoutInSeconds: this._settings.requestTimeoutInSeconds, initCredentials: this._settings.fetchRequestCredentials });
    return n.debug("got response"), d;
  }
  /**
   * Exchange a refresh token.
   *
   * @see https://www.rfc-editor.org/rfc/rfc6749#section-6
   */
  async exchangeRefreshToken({
    grant_type: e = "refresh_token",
    client_id: t = this._settings.client_id,
    client_secret: s = this._settings.client_secret,
    timeoutInSeconds: i,
    extraHeaders: r,
    ...n
  }) {
    const o = this._logger.create("exchangeRefreshToken");
    t || o.throw(new Error("A client_id is required")), n.refresh_token || o.throw(new Error("A refresh_token is required"));
    const c = new URLSearchParams({ grant_type: e });
    for (const [g, _] of Object.entries(n))
      Array.isArray(_) ? _.forEach((S) => c.append(g, S)) : _ != null && c.set(g, _);
    let l;
    switch (this._settings.client_authentication) {
      case "client_secret_basic":
        if (!s)
          throw o.throw(new Error("A client_secret is required")), null;
        l = C.generateBasicAuth(t, s);
        break;
      case "client_secret_post":
        c.append("client_id", t), s && c.append("client_secret", s);
        break;
    }
    const d = await this._metadataService.getTokenEndpoint(!1);
    o.debug("got token endpoint");
    const h = await this._jsonService.postForm(d, { body: c, basicAuth: l, timeoutInSeconds: i, initCredentials: this._settings.fetchRequestCredentials, extraHeaders: r });
    return o.debug("got response"), h;
  }
  /**
   * Revoke an access or refresh token.
   *
   * @see https://datatracker.ietf.org/doc/html/rfc7009#section-2.1
   */
  async revoke(e) {
    var t;
    const s = this._logger.create("revoke");
    e.token || s.throw(new Error("A token is required"));
    const i = await this._metadataService.getRevocationEndpoint(!1);
    s.debug(`got revocation endpoint, revoking ${(t = e.token_type_hint) != null ? t : "default token type"}`);
    const r = new URLSearchParams();
    for (const [n, o] of Object.entries(e))
      o != null && r.set(n, o);
    r.set("client_id", this._settings.client_id), this._settings.client_secret && r.set("client_secret", this._settings.client_secret), await this._jsonService.postForm(i, { body: r, timeoutInSeconds: this._settings.requestTimeoutInSeconds }), s.debug("got response");
  }
}, rs = class {
  constructor(e, t, s) {
    this._settings = e, this._metadataService = t, this._claimsService = s, this._logger = new u("ResponseValidator"), this._userInfoService = new is(this._settings, this._metadataService), this._tokenClient = new Xe(this._settings, this._metadataService);
  }
  async validateSigninResponse(e, t, s) {
    const i = this._logger.create("validateSigninResponse");
    this._processSigninState(e, t), i.debug("state processed"), await this._processCode(e, t, s), i.debug("code processed"), e.isOpenId && this._validateIdTokenAttributes(e), i.debug("tokens validated"), await this._processClaims(e, t == null ? void 0 : t.skipUserInfo, e.isOpenId), i.debug("claims processed");
  }
  async validateCredentialsResponse(e, t) {
    const s = this._logger.create("validateCredentialsResponse");
    e.isOpenId && e.id_token && this._validateIdTokenAttributes(e), s.debug("tokens validated"), await this._processClaims(e, t, e.isOpenId), s.debug("claims processed");
  }
  async validateRefreshResponse(e, t) {
    var s, i;
    const r = this._logger.create("validateRefreshResponse");
    e.userState = t.data, (s = e.session_state) != null || (e.session_state = t.session_state), (i = e.scope) != null || (e.scope = t.scope), e.isOpenId && e.id_token && (this._validateIdTokenAttributes(e, t.id_token), r.debug("ID Token validated")), e.id_token || (e.id_token = t.id_token, e.profile = t.profile);
    const n = e.isOpenId && !!e.id_token;
    await this._processClaims(e, !1, n), r.debug("claims processed");
  }
  validateSignoutResponse(e, t) {
    const s = this._logger.create("validateSignoutResponse");
    if (t.id !== e.state && s.throw(new Error("State does not match")), s.debug("state validated"), e.userState = t.data, e.error)
      throw s.warn("Response was error", e.error), new B(e);
  }
  _processSigninState(e, t) {
    var s;
    const i = this._logger.create("_processSigninState");
    if (t.id !== e.state && i.throw(new Error("State does not match")), t.client_id || i.throw(new Error("No client_id on state")), t.authority || i.throw(new Error("No authority on state")), this._settings.authority !== t.authority && i.throw(new Error("authority mismatch on settings vs. signin state")), this._settings.client_id && this._settings.client_id !== t.client_id && i.throw(new Error("client_id mismatch on settings vs. signin state")), i.debug("state validated"), e.userState = t.data, e.url_state = t.url_state, (s = e.scope) != null || (e.scope = t.scope), e.error)
      throw i.warn("Response was error", e.error), new B(e);
    t.code_verifier && !e.code && i.throw(new Error("Expected code in response"));
  }
  async _processClaims(e, t = !1, s = !0) {
    const i = this._logger.create("_processClaims");
    if (e.profile = this._claimsService.filterProtocolClaims(e.profile), t || !this._settings.loadUserInfo || !e.access_token) {
      i.debug("not loading user info");
      return;
    }
    i.debug("loading user info");
    const r = await this._userInfoService.getClaims(e.access_token);
    i.debug("user info claims received from user info endpoint"), s && r.sub !== e.profile.sub && i.throw(new Error("subject from UserInfo response does not match subject in ID Token")), e.profile = this._claimsService.mergeClaims(e.profile, this._claimsService.filterProtocolClaims(r)), i.debug("user info claims received, updated profile:", e.profile);
  }
  async _processCode(e, t, s) {
    const i = this._logger.create("_processCode");
    if (e.code) {
      i.debug("Validating code");
      const r = await this._tokenClient.exchangeCode({
        client_id: t.client_id,
        client_secret: t.client_secret,
        code: e.code,
        redirect_uri: t.redirect_uri,
        code_verifier: t.code_verifier,
        extraHeaders: s,
        ...t.extraTokenParams
      });
      Object.assign(e, r);
    } else
      i.debug("No code to process");
  }
  _validateIdTokenAttributes(e, t) {
    var s;
    const i = this._logger.create("_validateIdTokenAttributes");
    i.debug("decoding ID Token JWT");
    const r = he.decode((s = e.id_token) != null ? s : "");
    if (r.sub || i.throw(new Error("ID Token is missing a subject claim")), t) {
      const n = he.decode(t);
      r.sub !== n.sub && i.throw(new Error("sub in id_token does not match current sub")), r.auth_time && r.auth_time !== n.auth_time && i.throw(new Error("auth_time in id_token does not match original auth_time")), r.azp && r.azp !== n.azp && i.throw(new Error("azp in id_token does not match original azp")), !r.azp && n.azp && i.throw(new Error("azp not in id_token, but present in original id_token"));
    }
    e.profile = r;
  }
}, ge = class ke {
  constructor(t) {
    this.id = t.id || C.generateUUIDv4(), this.data = t.data, t.created && t.created > 0 ? this.created = t.created : this.created = F.getEpochTime(), this.request_type = t.request_type, this.url_state = t.url_state;
  }
  toStorageString() {
    return new u("State").create("toStorageString"), JSON.stringify({
      id: this.id,
      data: this.data,
      created: this.created,
      request_type: this.request_type,
      url_state: this.url_state
    });
  }
  static fromStorageString(t) {
    return u.createStatic("State", "fromStorageString"), Promise.resolve(new ke(JSON.parse(t)));
  }
  static async clearStaleState(t, s) {
    const i = u.createStatic("State", "clearStaleState"), r = F.getEpochTime() - s, n = await t.getAllKeys();
    i.debug("got keys", n);
    for (let o = 0; o < n.length; o++) {
      const c = n[o], l = await t.get(c);
      let d = !1;
      if (l)
        try {
          const h = await ke.fromStorageString(l);
          i.debug("got item from key:", c, h.created), h.created <= r && (d = !0);
        } catch (h) {
          i.error("Error parsing state for key:", c, h), d = !0;
        }
      else
        i.debug("no item in storage for key:", c), d = !0;
      d && (i.debug("removed item for key:", c), t.remove(c));
    }
  }
}, Ye = class Te extends ge {
  constructor(t) {
    super(t), this.code_verifier = t.code_verifier, this.code_challenge = t.code_challenge, this.authority = t.authority, this.client_id = t.client_id, this.redirect_uri = t.redirect_uri, this.scope = t.scope, this.client_secret = t.client_secret, this.extraTokenParams = t.extraTokenParams, this.response_mode = t.response_mode, this.skipUserInfo = t.skipUserInfo;
  }
  static async create(t) {
    const s = t.code_verifier === !0 ? C.generateCodeVerifier() : t.code_verifier || void 0, i = s ? await C.generateCodeChallenge(s) : void 0;
    return new Te({
      ...t,
      code_verifier: s,
      code_challenge: i
    });
  }
  toStorageString() {
    return new u("SigninState").create("toStorageString"), JSON.stringify({
      id: this.id,
      data: this.data,
      created: this.created,
      request_type: this.request_type,
      url_state: this.url_state,
      code_verifier: this.code_verifier,
      authority: this.authority,
      client_id: this.client_id,
      redirect_uri: this.redirect_uri,
      scope: this.scope,
      client_secret: this.client_secret,
      extraTokenParams: this.extraTokenParams,
      response_mode: this.response_mode,
      skipUserInfo: this.skipUserInfo
    });
  }
  static fromStorageString(t) {
    u.createStatic("SigninState", "fromStorageString");
    const s = JSON.parse(t);
    return Te.create(s);
  }
}, Ze = class et {
  constructor(t) {
    this.url = t.url, this.state = t.state;
  }
  static async create({
    // mandatory
    url: t,
    authority: s,
    client_id: i,
    redirect_uri: r,
    response_type: n,
    scope: o,
    // optional
    state_data: c,
    response_mode: l,
    request_type: d,
    client_secret: h,
    nonce: g,
    url_state: _,
    resource: S,
    skipUserInfo: x,
    extraQueryParams: T,
    extraTokenParams: A,
    disablePKCE: I,
    dpopJkt: N,
    omitScopeWhenRequesting: P,
    ...M
  }) {
    if (!t)
      throw this._logger.error("create: No url passed"), new Error("url");
    if (!i)
      throw this._logger.error("create: No client_id passed"), new Error("client_id");
    if (!r)
      throw this._logger.error("create: No redirect_uri passed"), new Error("redirect_uri");
    if (!n)
      throw this._logger.error("create: No response_type passed"), new Error("response_type");
    if (!o)
      throw this._logger.error("create: No scope passed"), new Error("scope");
    if (!s)
      throw this._logger.error("create: No authority passed"), new Error("authority");
    const R = await Ye.create({
      data: c,
      request_type: d,
      url_state: _,
      code_verifier: !I,
      client_id: i,
      authority: s,
      redirect_uri: r,
      response_mode: l,
      client_secret: h,
      scope: o,
      extraTokenParams: A,
      skipUserInfo: x
    }), m = new URL(t);
    m.searchParams.append("client_id", i), m.searchParams.append("redirect_uri", r), m.searchParams.append("response_type", n), P || m.searchParams.append("scope", o), g && m.searchParams.append("nonce", g), N && m.searchParams.append("dpop_jkt", N);
    let E = R.id;
    _ && (E = `${E}${Se}${_}`), m.searchParams.append("state", E), R.code_challenge && (m.searchParams.append("code_challenge", R.code_challenge), m.searchParams.append("code_challenge_method", "S256")), S && (Array.isArray(S) ? S : [S]).forEach((y) => m.searchParams.append("resource", y));
    for (const [U, y] of Object.entries({ response_mode: l, ...M, ...T }))
      y != null && m.searchParams.append(U, y.toString());
    return new et({
      url: m.href,
      state: R
    });
  }
};
Ze._logger = new u("SigninRequest");
var ns = Ze, os = "openid", pe = class {
  constructor(e) {
    if (this.access_token = "", this.token_type = "", this.profile = {}, this.state = e.get("state"), this.session_state = e.get("session_state"), this.state) {
      const t = decodeURIComponent(this.state).split(Se);
      this.state = t[0], t.length > 1 && (this.url_state = t.slice(1).join(Se));
    }
    this.error = e.get("error"), this.error_description = e.get("error_description"), this.error_uri = e.get("error_uri"), this.code = e.get("code");
  }
  get expires_in() {
    if (this.expires_at !== void 0)
      return this.expires_at - F.getEpochTime();
  }
  set expires_in(e) {
    typeof e == "string" && (e = Number(e)), e !== void 0 && e >= 0 && (this.expires_at = Math.floor(e) + F.getEpochTime());
  }
  get isOpenId() {
    var e;
    return ((e = this.scope) == null ? void 0 : e.split(" ").includes(os)) || !!this.id_token;
  }
}, as = class {
  constructor({
    url: e,
    state_data: t,
    id_token_hint: s,
    post_logout_redirect_uri: i,
    extraQueryParams: r,
    request_type: n,
    client_id: o
  }) {
    if (this._logger = new u("SignoutRequest"), !e)
      throw this._logger.error("ctor: No url passed"), new Error("url");
    const c = new URL(e);
    s && c.searchParams.append("id_token_hint", s), o && c.searchParams.append("client_id", o), i && (c.searchParams.append("post_logout_redirect_uri", i), t && (this.state = new ge({ data: t, request_type: n }), c.searchParams.append("state", this.state.id)));
    for (const [l, d] of Object.entries({ ...r }))
      d != null && c.searchParams.append(l, d.toString());
    this.url = c.href;
  }
}, cs = class {
  constructor(e) {
    this.state = e.get("state"), this.error = e.get("error"), this.error_description = e.get("error_description"), this.error_uri = e.get("error_uri");
  }
}, ls = [
  "nbf",
  "jti",
  "auth_time",
  "nonce",
  "acr",
  "amr",
  "azp",
  "at_hash"
  // https://openid.net/specs/openid-connect-core-1_0.html#CodeIDToken
], ds = ["sub", "iss", "aud", "exp", "iat"], hs = class {
  constructor(e) {
    this._settings = e, this._logger = new u("ClaimsService");
  }
  filterProtocolClaims(e) {
    const t = { ...e };
    if (this._settings.filterProtocolClaims) {
      let s;
      Array.isArray(this._settings.filterProtocolClaims) ? s = this._settings.filterProtocolClaims : s = ls;
      for (const i of s)
        ds.includes(i) || delete t[i];
    }
    return t;
  }
  mergeClaims(e, t) {
    const s = { ...e };
    for (const [i, r] of Object.entries(t))
      if (s[i] !== r)
        if (Array.isArray(s[i]) || Array.isArray(r))
          if (this._settings.mergeClaimsStrategy.array == "replace")
            s[i] = r;
          else {
            const n = Array.isArray(s[i]) ? s[i] : [s[i]];
            for (const o of Array.isArray(r) ? r : [r])
              n.includes(o) || n.push(o);
            s[i] = n;
          }
        else typeof s[i] == "object" && typeof r == "object" ? s[i] = this.mergeClaims(s[i], r) : s[i] = r;
    return s;
  }
}, tt = class {
  constructor(e, t) {
    this.keys = e, this.nonce = t;
  }
}, gs = class {
  constructor(e, t) {
    this._logger = new u("OidcClient"), this.settings = e instanceof be ? e : new be(e), this.metadataService = t ?? new Yt(this.settings), this._claimsService = new hs(this.settings), this._validator = new rs(this.settings, this.metadataService, this._claimsService), this._tokenClient = new Xe(this.settings, this.metadataService);
  }
  async createSigninRequest({
    state: e,
    request: t,
    request_uri: s,
    request_type: i,
    id_token_hint: r,
    login_hint: n,
    skipUserInfo: o,
    nonce: c,
    url_state: l,
    response_type: d = this.settings.response_type,
    scope: h = this.settings.scope,
    redirect_uri: g = this.settings.redirect_uri,
    prompt: _ = this.settings.prompt,
    display: S = this.settings.display,
    max_age: x = this.settings.max_age,
    ui_locales: T = this.settings.ui_locales,
    acr_values: A = this.settings.acr_values,
    resource: I = this.settings.resource,
    response_mode: N = this.settings.response_mode,
    extraQueryParams: P = this.settings.extraQueryParams,
    extraTokenParams: M = this.settings.extraTokenParams,
    dpopJkt: R,
    omitScopeWhenRequesting: m = this.settings.omitScopeWhenRequesting
  }) {
    const E = this._logger.create("createSigninRequest");
    if (d !== "code")
      throw new Error("Only the Authorization Code flow (with PKCE) is supported");
    const U = await this.metadataService.getAuthorizationEndpoint();
    E.debug("Received authorization endpoint", U);
    const y = await ns.create({
      url: U,
      authority: this.settings.authority,
      client_id: this.settings.client_id,
      redirect_uri: g,
      response_type: d,
      scope: h,
      state_data: e,
      url_state: l,
      prompt: _,
      display: S,
      max_age: x,
      ui_locales: T,
      id_token_hint: r,
      login_hint: n,
      acr_values: A,
      dpopJkt: R,
      resource: I,
      request: t,
      request_uri: s,
      extraQueryParams: P,
      extraTokenParams: M,
      request_type: i,
      response_mode: N,
      client_secret: this.settings.client_secret,
      skipUserInfo: o,
      nonce: c,
      disablePKCE: this.settings.disablePKCE,
      omitScopeWhenRequesting: m
    });
    await this.clearStaleState();
    const z = y.state;
    return await this.settings.stateStore.set(z.id, z.toStorageString()), y;
  }
  async readSigninResponseState(e, t = !1) {
    const s = this._logger.create("readSigninResponseState"), i = new pe(ve.readParams(e, this.settings.response_mode));
    if (!i.state)
      throw s.throw(new Error("No state in response")), null;
    const r = await this.settings.stateStore[t ? "remove" : "get"](i.state);
    if (!r)
      throw s.throw(new Error("No matching state found in storage")), null;
    return { state: await Ye.fromStorageString(r), response: i };
  }
  async processSigninResponse(e, t) {
    const s = this._logger.create("processSigninResponse"), { state: i, response: r } = await this.readSigninResponseState(e, !0);
    if (s.debug("received state from storage; validating response"), this.settings.dpop && this.settings.dpop.store) {
      const n = await this.getDpopProof(this.settings.dpop.store);
      t = { ...t, DPoP: n };
    }
    try {
      await this._validator.validateSigninResponse(r, i, t);
    } catch (n) {
      if (n instanceof ye && this.settings.dpop) {
        const o = await this.getDpopProof(this.settings.dpop.store, n.nonce);
        t.DPoP = o, await this._validator.validateSigninResponse(r, i, t);
      } else
        throw n;
    }
    return r;
  }
  async getDpopProof(e, t) {
    let s, i;
    return (await e.getAllKeys()).includes(this.settings.client_id) ? (i = await e.get(this.settings.client_id), i.nonce !== t && t && (i.nonce = t, await e.set(this.settings.client_id, i))) : (s = await C.generateDPoPKeys(), i = new tt(s, t), await e.set(this.settings.client_id, i)), await C.generateDPoPProof({
      url: await this.metadataService.getTokenEndpoint(!1),
      httpMethod: "POST",
      keyPair: i.keys,
      nonce: i.nonce
    });
  }
  async processResourceOwnerPasswordCredentials({
    username: e,
    password: t,
    skipUserInfo: s = !1,
    extraTokenParams: i = {}
  }) {
    const r = await this._tokenClient.exchangeCredentials({ username: e, password: t, ...i }), n = new pe(new URLSearchParams());
    return Object.assign(n, r), await this._validator.validateCredentialsResponse(n, s), n;
  }
  async useRefreshToken({
    state: e,
    redirect_uri: t,
    resource: s,
    timeoutInSeconds: i,
    extraHeaders: r,
    extraTokenParams: n
  }) {
    var o;
    const c = this._logger.create("useRefreshToken");
    let l;
    if (this.settings.refreshTokenAllowedScope === void 0)
      l = e.scope;
    else {
      const g = this.settings.refreshTokenAllowedScope.split(" ");
      l = (((o = e.scope) == null ? void 0 : o.split(" ")) || []).filter((S) => g.includes(S)).join(" ");
    }
    if (this.settings.dpop && this.settings.dpop.store) {
      const g = await this.getDpopProof(this.settings.dpop.store);
      r = { ...r, DPoP: g };
    }
    let d;
    try {
      d = await this._tokenClient.exchangeRefreshToken({
        refresh_token: e.refresh_token,
        // provide the (possible filtered) scope list
        scope: l,
        redirect_uri: t,
        resource: s,
        timeoutInSeconds: i,
        extraHeaders: r,
        ...n
      });
    } catch (g) {
      if (g instanceof ye && this.settings.dpop)
        r.DPoP = await this.getDpopProof(this.settings.dpop.store, g.nonce), d = await this._tokenClient.exchangeRefreshToken({
          refresh_token: e.refresh_token,
          // provide the (possible filtered) scope list
          scope: l,
          redirect_uri: t,
          resource: s,
          timeoutInSeconds: i,
          extraHeaders: r,
          ...n
        });
      else
        throw g;
    }
    const h = new pe(new URLSearchParams());
    return Object.assign(h, d), c.debug("validating response", h), await this._validator.validateRefreshResponse(h, {
      ...e,
      // override the scope in the state handed over to the validator
      // so it can set the granted scope to the requested scope in case none is included in the response
      scope: l
    }), h;
  }
  async createSignoutRequest({
    state: e,
    id_token_hint: t,
    client_id: s,
    request_type: i,
    post_logout_redirect_uri: r = this.settings.post_logout_redirect_uri,
    extraQueryParams: n = this.settings.extraQueryParams
  } = {}) {
    const o = this._logger.create("createSignoutRequest"), c = await this.metadataService.getEndSessionEndpoint();
    if (!c)
      throw o.throw(new Error("No end session endpoint")), null;
    o.debug("Received end session endpoint", c), !s && r && !t && (s = this.settings.client_id);
    const l = new as({
      url: c,
      id_token_hint: t,
      client_id: s,
      post_logout_redirect_uri: r,
      state_data: e,
      extraQueryParams: n,
      request_type: i
    });
    await this.clearStaleState();
    const d = l.state;
    return d && (o.debug("Signout request has state to persist"), await this.settings.stateStore.set(d.id, d.toStorageString())), l;
  }
  async readSignoutResponseState(e, t = !1) {
    const s = this._logger.create("readSignoutResponseState"), i = new cs(ve.readParams(e, this.settings.response_mode));
    if (!i.state) {
      if (s.debug("No state in response"), i.error)
        throw s.warn("Response was error:", i.error), new B(i);
      return { state: void 0, response: i };
    }
    const r = await this.settings.stateStore[t ? "remove" : "get"](i.state);
    if (!r)
      throw s.throw(new Error("No matching state found in storage")), null;
    return { state: await ge.fromStorageString(r), response: i };
  }
  async processSignoutResponse(e) {
    const t = this._logger.create("processSignoutResponse"), { state: s, response: i } = await this.readSignoutResponseState(e, !0);
    return s ? (t.debug("Received state from storage; validating response"), this._validator.validateSignoutResponse(i, s)) : t.debug("No state from storage; skipping response validation"), i;
  }
  clearStaleState() {
    return this._logger.create("clearStaleState"), ge.clearStaleState(this.settings.stateStore, this.settings.staleStateAgeInSeconds);
  }
  async revokeToken(e, t) {
    return this._logger.create("revokeToken"), await this._tokenClient.revoke({
      token: e,
      token_type_hint: t
    });
  }
}, us = class {
  constructor(e) {
    this._userManager = e, this._logger = new u("SessionMonitor"), this._start = async (t) => {
      const s = t.session_state;
      if (!s)
        return;
      const i = this._logger.create("_start");
      if (t.profile ? (this._sub = t.profile.sub, i.debug("session_state", s, ", sub", this._sub)) : (this._sub = void 0, i.debug("session_state", s, ", anonymous user")), this._checkSessionIFrame) {
        this._checkSessionIFrame.start(s);
        return;
      }
      try {
        const r = await this._userManager.metadataService.getCheckSessionIframe();
        if (r) {
          i.debug("initializing check session iframe");
          const n = this._userManager.settings.client_id, o = this._userManager.settings.checkSessionIntervalInSeconds, c = this._userManager.settings.stopCheckSessionOnError, l = new Xt(this._callback, n, r, o, c);
          await l.load(), this._checkSessionIFrame = l, l.start(s);
        } else
          i.warn("no check session iframe found in the metadata");
      } catch (r) {
        i.error("Error from getCheckSessionIframe:", r instanceof Error ? r.message : r);
      }
    }, this._stop = () => {
      const t = this._logger.create("_stop");
      if (this._sub = void 0, this._checkSessionIFrame && this._checkSessionIFrame.stop(), this._userManager.settings.monitorAnonymousSession) {
        const s = setInterval(async () => {
          clearInterval(s);
          try {
            const i = await this._userManager.querySessionStatus();
            if (i) {
              const r = {
                session_state: i.session_state,
                profile: i.sub ? {
                  sub: i.sub
                } : null
              };
              this._start(r);
            }
          } catch (i) {
            t.error("error from querySessionStatus", i instanceof Error ? i.message : i);
          }
        }, 1e3);
      }
    }, this._callback = async () => {
      const t = this._logger.create("_callback");
      try {
        const s = await this._userManager.querySessionStatus();
        let i = !0;
        s && this._checkSessionIFrame ? s.sub === this._sub ? (i = !1, this._checkSessionIFrame.start(s.session_state), t.debug("same sub still logged in at OP, session state has changed, restarting check session iframe; session_state", s.session_state), await this._userManager.events._raiseUserSessionChanged()) : t.debug("different subject signed into OP", s.sub) : t.debug("subject no longer signed into OP"), i ? this._sub ? await this._userManager.events._raiseUserSignedOut() : await this._userManager.events._raiseUserSignedIn() : t.debug("no change in session detected, no event to raise");
      } catch (s) {
        this._sub && (t.debug("Error calling queryCurrentSigninSession; raising signed out event", s), await this._userManager.events._raiseUserSignedOut());
      }
    }, e || this._logger.throw(new Error("No user manager passed")), this._userManager.events.addUserLoaded(this._start), this._userManager.events.addUserUnloaded(this._stop), this._init().catch((t) => {
      this._logger.error(t);
    });
  }
  async _init() {
    this._logger.create("_init");
    const e = await this._userManager.getUser();
    if (e)
      this._start(e);
    else if (this._userManager.settings.monitorAnonymousSession) {
      const t = await this._userManager.querySessionStatus();
      if (t) {
        const s = {
          session_state: t.session_state,
          profile: t.sub ? {
            sub: t.sub
          } : null
        };
        this._start(s);
      }
    }
  }
}, fe = class st {
  constructor(t) {
    var s;
    this.id_token = t.id_token, this.session_state = (s = t.session_state) != null ? s : null, this.access_token = t.access_token, this.refresh_token = t.refresh_token, this.token_type = t.token_type, this.scope = t.scope, this.profile = t.profile, this.expires_at = t.expires_at, this.state = t.userState, this.url_state = t.url_state;
  }
  /** Computed number of seconds the access token has remaining. */
  get expires_in() {
    if (this.expires_at !== void 0)
      return this.expires_at - F.getEpochTime();
  }
  set expires_in(t) {
    t !== void 0 && (this.expires_at = Math.floor(t) + F.getEpochTime());
  }
  /** Computed value indicating if the access token is expired. */
  get expired() {
    const t = this.expires_in;
    if (t !== void 0)
      return t <= 0;
  }
  /** Array representing the parsed values from the `scope`. */
  get scopes() {
    var t, s;
    return (s = (t = this.scope) == null ? void 0 : t.split(" ")) != null ? s : [];
  }
  toStorageString() {
    return new u("User").create("toStorageString"), JSON.stringify({
      id_token: this.id_token,
      session_state: this.session_state,
      access_token: this.access_token,
      refresh_token: this.refresh_token,
      token_type: this.token_type,
      scope: this.scope,
      profile: this.profile,
      expires_at: this.expires_at
    });
  }
  static fromStorageString(t) {
    return u.createStatic("User", "fromStorageString"), new st(JSON.parse(t));
  }
}, Me = "oidc-client", it = class {
  constructor() {
    this._abort = new W("Window navigation aborted"), this._disposeHandlers = /* @__PURE__ */ new Set(), this._window = null;
  }
  async navigate(e) {
    const t = this._logger.create("navigate");
    if (!this._window)
      throw new Error("Attempted to navigate on a disposed window");
    t.debug("setting URL in window"), this._window.location.replace(e.url);
    const { url: s, keepOpen: i } = await new Promise((r, n) => {
      const o = (c) => {
        var l;
        const d = c.data, h = (l = e.scriptOrigin) != null ? l : window.location.origin;
        if (!(c.origin !== h || (d == null ? void 0 : d.source) !== Me)) {
          try {
            const g = ve.readParams(d.url, e.response_mode).get("state");
            if (g || t.warn("no state found in response url"), c.source !== this._window && g !== e.state)
              return;
          } catch {
            this._dispose(), n(new Error("Invalid response from window"));
          }
          r(d);
        }
      };
      window.addEventListener("message", o, !1), this._disposeHandlers.add(() => window.removeEventListener("message", o, !1)), this._disposeHandlers.add(this._abort.addHandler((c) => {
        this._dispose(), n(c);
      }));
    });
    return t.debug("got response from window"), this._dispose(), i || this.close(), { url: s };
  }
  _dispose() {
    this._logger.create("_dispose");
    for (const e of this._disposeHandlers)
      e();
    this._disposeHandlers.clear();
  }
  static _notifyParent(e, t, s = !1, i = window.location.origin) {
    e.postMessage({
      source: Me,
      url: t,
      keepOpen: s
    }, i);
  }
}, rt = {
  location: !1,
  toolbar: !1,
  height: 640,
  closePopupWindowAfterInSeconds: -1
}, nt = "_blank", _s = 60, ps = 2, ot = 10, fs = class extends be {
  constructor(e) {
    const {
      popup_redirect_uri: t = e.redirect_uri,
      popup_post_logout_redirect_uri: s = e.post_logout_redirect_uri,
      popupWindowFeatures: i = rt,
      popupWindowTarget: r = nt,
      redirectMethod: n = "assign",
      redirectTarget: o = "self",
      iframeNotifyParentOrigin: c = e.iframeNotifyParentOrigin,
      iframeScriptOrigin: l = e.iframeScriptOrigin,
      requestTimeoutInSeconds: d,
      silent_redirect_uri: h = e.redirect_uri,
      silentRequestTimeoutInSeconds: g,
      automaticSilentRenew: _ = !0,
      validateSubOnSilentRenew: S = !0,
      includeIdTokenInSilentRenew: x = !1,
      monitorSession: T = !1,
      monitorAnonymousSession: A = !1,
      checkSessionIntervalInSeconds: I = ps,
      query_status_response_type: N = "code",
      stopCheckSessionOnError: P = !0,
      revokeTokenTypes: M = ["access_token", "refresh_token"],
      revokeTokensOnSignout: R = !1,
      includeIdTokenInSilentSignout: m = !1,
      accessTokenExpiringNotificationTimeInSeconds: E = _s,
      userStore: U
    } = e;
    if (super(e), this.popup_redirect_uri = t, this.popup_post_logout_redirect_uri = s, this.popupWindowFeatures = i, this.popupWindowTarget = r, this.redirectMethod = n, this.redirectTarget = o, this.iframeNotifyParentOrigin = c, this.iframeScriptOrigin = l, this.silent_redirect_uri = h, this.silentRequestTimeoutInSeconds = g || d || ot, this.automaticSilentRenew = _, this.validateSubOnSilentRenew = S, this.includeIdTokenInSilentRenew = x, this.monitorSession = T, this.monitorAnonymousSession = A, this.checkSessionIntervalInSeconds = I, this.stopCheckSessionOnError = P, this.query_status_response_type = N, this.revokeTokenTypes = M, this.revokeTokensOnSignout = R, this.includeIdTokenInSilentSignout = m, this.accessTokenExpiringNotificationTimeInSeconds = E, U)
      this.userStore = U;
    else {
      const y = typeof window < "u" ? window.sessionStorage : new Ge();
      this.userStore = new Qe({ store: y });
    }
  }
}, Fe = class at extends it {
  constructor({
    silentRequestTimeoutInSeconds: t = ot
  }) {
    super(), this._logger = new u("IFrameWindow"), this._timeoutInSeconds = t, this._frame = at.createHiddenIframe(), this._window = this._frame.contentWindow;
  }
  static createHiddenIframe() {
    const t = window.document.createElement("iframe");
    return t.style.visibility = "hidden", t.style.position = "fixed", t.style.left = "-1000px", t.style.top = "0", t.width = "0", t.height = "0", window.document.body.appendChild(t), t;
  }
  async navigate(t) {
    this._logger.debug("navigate: Using timeout of:", this._timeoutInSeconds);
    const s = setTimeout(() => void this._abort.raise(new Ae("IFrame timed out without a response")), this._timeoutInSeconds * 1e3);
    return this._disposeHandlers.add(() => clearTimeout(s)), await super.navigate(t);
  }
  close() {
    var t;
    this._frame && (this._frame.parentNode && (this._frame.addEventListener("load", (s) => {
      var i;
      const r = s.target;
      (i = r.parentNode) == null || i.removeChild(r), this._abort.raise(new Error("IFrame removed from DOM"));
    }, !0), (t = this._frame.contentWindow) == null || t.location.replace("about:blank")), this._frame = null), this._window = null;
  }
  static notifyParent(t, s) {
    return super._notifyParent(window.parent, t, !1, s);
  }
}, ms = class {
  constructor(e) {
    this._settings = e, this._logger = new u("IFrameNavigator");
  }
  async prepare({
    silentRequestTimeoutInSeconds: e = this._settings.silentRequestTimeoutInSeconds
  }) {
    return new Fe({ silentRequestTimeoutInSeconds: e });
  }
  async callback(e) {
    this._logger.create("callback"), Fe.notifyParent(e, this._settings.iframeNotifyParentOrigin);
  }
}, ws = 500, vs = 1e3, We = class extends it {
  constructor({
    popupWindowTarget: e = nt,
    popupWindowFeatures: t = {},
    popupSignal: s
  }) {
    super(), this._logger = new u("PopupWindow");
    const i = $e.center({ ...rt, ...t });
    this._window = window.open(void 0, e, $e.serialize(i)), s && s.addEventListener("abort", () => {
      var r;
      this._abort.raise(new Error((r = s.reason) != null ? r : "Popup aborted"));
    }), t.closePopupWindowAfterInSeconds && t.closePopupWindowAfterInSeconds > 0 && setTimeout(() => {
      if (!this._window || typeof this._window.closed != "boolean" || this._window.closed) {
        this._abort.raise(new Error("Popup blocked by user"));
        return;
      }
      this.close();
    }, t.closePopupWindowAfterInSeconds * vs);
  }
  async navigate(e) {
    var t;
    (t = this._window) == null || t.focus();
    const s = setInterval(() => {
      (!this._window || this._window.closed) && this._abort.raise(new Error("Popup closed by user"));
    }, ws);
    return this._disposeHandlers.add(() => clearInterval(s)), await super.navigate(e);
  }
  close() {
    this._window && (this._window.closed || (this._window.close(), this._abort.raise(new Error("Popup closed")))), this._window = null;
  }
  static notifyOpener(e, t) {
    if (!window.opener)
      throw new Error("No window.opener. Can't complete notification.");
    return super._notifyParent(window.opener, e, t);
  }
}, Ss = class {
  constructor(e) {
    this._settings = e, this._logger = new u("PopupNavigator");
  }
  async prepare({
    popupWindowFeatures: e = this._settings.popupWindowFeatures,
    popupWindowTarget: t = this._settings.popupWindowTarget,
    popupSignal: s
  }) {
    return new We({ popupWindowFeatures: e, popupWindowTarget: t, popupSignal: s });
  }
  async callback(e, { keepOpen: t = !1 }) {
    this._logger.create("callback"), We.notifyOpener(e, t);
  }
}, ys = class {
  constructor(e) {
    this._settings = e, this._logger = new u("RedirectNavigator");
  }
  async prepare({
    redirectMethod: e = this._settings.redirectMethod,
    redirectTarget: t = this._settings.redirectTarget
  }) {
    var s;
    this._logger.create("prepare");
    let i = window.self;
    t === "top" && (i = (s = window.top) != null ? s : window.self);
    const r = i.location[e].bind(i.location);
    let n;
    return {
      navigate: async (o) => {
        this._logger.create("navigate");
        const c = new Promise((l, d) => {
          n = d;
        });
        return r(o.url), await c;
      },
      close: () => {
        this._logger.create("close"), n == null || n(new Error("Redirect aborted")), i.stop();
      }
    };
  }
  async callback() {
  }
}, bs = class extends Qt {
  constructor(e) {
    super({ expiringNotificationTimeInSeconds: e.accessTokenExpiringNotificationTimeInSeconds }), this._logger = new u("UserManagerEvents"), this._userLoaded = new W("User loaded"), this._userUnloaded = new W("User unloaded"), this._silentRenewError = new W("Silent renew error"), this._userSignedIn = new W("User signed in"), this._userSignedOut = new W("User signed out"), this._userSessionChanged = new W("User session changed");
  }
  async load(e, t = !0) {
    super.load(e), t && await this._userLoaded.raise(e);
  }
  async unload() {
    super.unload(), await this._userUnloaded.raise();
  }
  /**
   * Add callback: Raised when a user session has been established (or re-established).
   */
  addUserLoaded(e) {
    return this._userLoaded.addHandler(e);
  }
  /**
   * Remove callback: Raised when a user session has been established (or re-established).
   */
  removeUserLoaded(e) {
    return this._userLoaded.removeHandler(e);
  }
  /**
   * Add callback: Raised when a user session has been terminated.
   */
  addUserUnloaded(e) {
    return this._userUnloaded.addHandler(e);
  }
  /**
   * Remove callback: Raised when a user session has been terminated.
   */
  removeUserUnloaded(e) {
    return this._userUnloaded.removeHandler(e);
  }
  /**
   * Add callback: Raised when the automatic silent renew has failed.
   */
  addSilentRenewError(e) {
    return this._silentRenewError.addHandler(e);
  }
  /**
   * Remove callback: Raised when the automatic silent renew has failed.
   */
  removeSilentRenewError(e) {
    return this._silentRenewError.removeHandler(e);
  }
  /**
   * @internal
   */
  async _raiseSilentRenewError(e) {
    await this._silentRenewError.raise(e);
  }
  /**
   * Add callback: Raised when the user is signed in (when `monitorSession` is set).
   * @see {@link UserManagerSettings.monitorSession}
   */
  addUserSignedIn(e) {
    return this._userSignedIn.addHandler(e);
  }
  /**
   * Remove callback: Raised when the user is signed in (when `monitorSession` is set).
   */
  removeUserSignedIn(e) {
    this._userSignedIn.removeHandler(e);
  }
  /**
   * @internal
   */
  async _raiseUserSignedIn() {
    await this._userSignedIn.raise();
  }
  /**
   * Add callback: Raised when the user's sign-in status at the OP has changed (when `monitorSession` is set).
   * @see {@link UserManagerSettings.monitorSession}
   */
  addUserSignedOut(e) {
    return this._userSignedOut.addHandler(e);
  }
  /**
   * Remove callback: Raised when the user's sign-in status at the OP has changed (when `monitorSession` is set).
   */
  removeUserSignedOut(e) {
    this._userSignedOut.removeHandler(e);
  }
  /**
   * @internal
   */
  async _raiseUserSignedOut() {
    await this._userSignedOut.raise();
  }
  /**
   * Add callback: Raised when the user session changed (when `monitorSession` is set).
   * @see {@link UserManagerSettings.monitorSession}
   */
  addUserSessionChanged(e) {
    return this._userSessionChanged.addHandler(e);
  }
  /**
   * Remove callback: Raised when the user session changed (when `monitorSession` is set).
   */
  removeUserSessionChanged(e) {
    this._userSessionChanged.removeHandler(e);
  }
  /**
   * @internal
   */
  async _raiseUserSessionChanged() {
    await this._userSessionChanged.raise();
  }
}, ks = class {
  constructor(e) {
    this._userManager = e, this._logger = new u("SilentRenewService"), this._isStarted = !1, this._retryTimer = new F("Retry Silent Renew"), this._tokenExpiring = async () => {
      const t = this._logger.create("_tokenExpiring");
      try {
        await this._userManager.signinSilent(), t.debug("silent token renewal successful");
      } catch (s) {
        if (s instanceof Ae) {
          t.warn("ErrorTimeout from signinSilent:", s, "retry in 5s"), this._retryTimer.init(5);
          return;
        }
        t.error("Error from signinSilent:", s), await this._userManager.events._raiseSilentRenewError(s);
      }
    };
  }
  async start() {
    const e = this._logger.create("start");
    if (!this._isStarted) {
      this._isStarted = !0, this._userManager.events.addAccessTokenExpiring(this._tokenExpiring), this._retryTimer.addHandler(this._tokenExpiring);
      try {
        await this._userManager.getUser();
      } catch (t) {
        e.error("getUser error", t);
      }
    }
  }
  stop() {
    this._isStarted && (this._retryTimer.cancel(), this._retryTimer.removeHandler(this._tokenExpiring), this._userManager.events.removeAccessTokenExpiring(this._tokenExpiring), this._isStarted = !1);
  }
}, Ts = class {
  constructor(e) {
    this.refresh_token = e.refresh_token, this.id_token = e.id_token, this.session_state = e.session_state, this.scope = e.scope, this.profile = e.profile, this.data = e.state;
  }
}, Is = class {
  constructor(e, t, s, i) {
    this._logger = new u("UserManager"), this.settings = new fs(e), this._client = new gs(e), this._redirectNavigator = t ?? new ys(this.settings), this._popupNavigator = s ?? new Ss(this.settings), this._iframeNavigator = i ?? new ms(this.settings), this._events = new bs(this.settings), this._silentRenewService = new ks(this), this.settings.automaticSilentRenew && this.startSilentRenew(), this._sessionMonitor = null, this.settings.monitorSession && (this._sessionMonitor = new us(this));
  }
  /**
   * Get object used to register for events raised by the `UserManager`.
   */
  get events() {
    return this._events;
  }
  /**
   * Get object used to access the metadata configuration of the identity provider.
   */
  get metadataService() {
    return this._client.metadataService;
  }
  /**
   * Load the `User` object for the currently authenticated user.
   *
   * @returns A promise
   */
  async getUser() {
    const e = this._logger.create("getUser"), t = await this._loadUser();
    return t ? (e.info("user loaded"), await this._events.load(t, !1), t) : (e.info("user not found in storage"), null);
  }
  /**
   * Remove from any storage the currently authenticated user.
   *
   * @returns A promise
   */
  async removeUser() {
    const e = this._logger.create("removeUser");
    await this.storeUser(null), e.info("user removed from storage"), await this._events.unload();
  }
  /**
   * Trigger a redirect of the current window to the authorization endpoint.
   *
   * @returns A promise
   *
   * @throws `Error` In cases of wrong authentication.
   */
  async signinRedirect(e = {}) {
    var t;
    this._logger.create("signinRedirect");
    const {
      redirectMethod: s,
      ...i
    } = e;
    let r;
    (t = this.settings.dpop) != null && t.bind_authorization_code && (r = await this.generateDPoPJkt(this.settings.dpop));
    const n = await this._redirectNavigator.prepare({ redirectMethod: s });
    await this._signinStart({
      request_type: "si:r",
      dpopJkt: r,
      ...i
    }, n);
  }
  /**
   * Process the response (callback) from the authorization endpoint.
   * It is recommended to use {@link UserManager.signinCallback} instead.
   *
   * @returns A promise containing the authenticated `User`.
   *
   * @see {@link UserManager.signinCallback}
   */
  async signinRedirectCallback(e = window.location.href) {
    const t = this._logger.create("signinRedirectCallback"), s = await this._signinEnd(e);
    return s.profile && s.profile.sub ? t.info("success, signed in subject", s.profile.sub) : t.info("no subject"), s;
  }
  /**
   * Trigger the signin with user/password.
   *
   * @returns A promise containing the authenticated `User`.
   * @throws {@link ErrorResponse} In cases of wrong authentication.
   */
  async signinResourceOwnerCredentials({
    username: e,
    password: t,
    skipUserInfo: s = !1
  }) {
    const i = this._logger.create("signinResourceOwnerCredential"), r = await this._client.processResourceOwnerPasswordCredentials({
      username: e,
      password: t,
      skipUserInfo: s,
      extraTokenParams: this.settings.extraTokenParams
    });
    i.debug("got signin response");
    const n = await this._buildUser(r);
    return n.profile && n.profile.sub ? i.info("success, signed in subject", n.profile.sub) : i.info("no subject"), n;
  }
  /**
   * Trigger a request (via a popup window) to the authorization endpoint.
   *
   * @returns A promise containing the authenticated `User`.
   * @throws `Error` In cases of wrong authentication.
   */
  async signinPopup(e = {}) {
    var t;
    const s = this._logger.create("signinPopup");
    let i;
    (t = this.settings.dpop) != null && t.bind_authorization_code && (i = await this.generateDPoPJkt(this.settings.dpop));
    const {
      popupWindowFeatures: r,
      popupWindowTarget: n,
      popupSignal: o,
      ...c
    } = e, l = this.settings.popup_redirect_uri;
    l || s.throw(new Error("No popup_redirect_uri configured"));
    const d = await this._popupNavigator.prepare({ popupWindowFeatures: r, popupWindowTarget: n, popupSignal: o }), h = await this._signin({
      request_type: "si:p",
      redirect_uri: l,
      display: "popup",
      dpopJkt: i,
      ...c
    }, d);
    return h && (h.profile && h.profile.sub ? s.info("success, signed in subject", h.profile.sub) : s.info("no subject")), h;
  }
  /**
   * Notify the opening window of response (callback) from the authorization endpoint.
   * It is recommended to use {@link UserManager.signinCallback} instead.
   *
   * @returns A promise
   *
   * @see {@link UserManager.signinCallback}
   */
  async signinPopupCallback(e = window.location.href, t = !1) {
    const s = this._logger.create("signinPopupCallback");
    await this._popupNavigator.callback(e, { keepOpen: t }), s.info("success");
  }
  /**
   * Trigger a silent request (via refresh token or an iframe) to the authorization endpoint.
   *
   * @returns A promise that contains the authenticated `User`.
   */
  async signinSilent(e = {}) {
    var t, s;
    const i = this._logger.create("signinSilent"), {
      silentRequestTimeoutInSeconds: r,
      ...n
    } = e;
    let o = await this._loadUser();
    if (o != null && o.refresh_token) {
      i.debug("using refresh token");
      const g = new Ts(o);
      return await this._useRefreshToken({
        state: g,
        redirect_uri: n.redirect_uri,
        resource: n.resource,
        extraTokenParams: n.extraTokenParams,
        timeoutInSeconds: r
      });
    }
    let c;
    (t = this.settings.dpop) != null && t.bind_authorization_code && (c = await this.generateDPoPJkt(this.settings.dpop));
    const l = this.settings.silent_redirect_uri;
    l || i.throw(new Error("No silent_redirect_uri configured"));
    let d;
    o && this.settings.validateSubOnSilentRenew && (i.debug("subject prior to silent renew:", o.profile.sub), d = o.profile.sub);
    const h = await this._iframeNavigator.prepare({ silentRequestTimeoutInSeconds: r });
    return o = await this._signin({
      request_type: "si:s",
      redirect_uri: l,
      prompt: "none",
      id_token_hint: this.settings.includeIdTokenInSilentRenew ? o == null ? void 0 : o.id_token : void 0,
      dpopJkt: c,
      ...n
    }, h, d), o && ((s = o.profile) != null && s.sub ? i.info("success, signed in subject", o.profile.sub) : i.info("no subject")), o;
  }
  async _useRefreshToken(e) {
    const t = await this._client.useRefreshToken({
      timeoutInSeconds: this.settings.silentRequestTimeoutInSeconds,
      ...e
    }), s = new fe({ ...e.state, ...t });
    return await this.storeUser(s), await this._events.load(s), s;
  }
  /**
   *
   * Notify the parent window of response (callback) from the authorization endpoint.
   * It is recommended to use {@link UserManager.signinCallback} instead.
   *
   * @returns A promise
   *
   * @see {@link UserManager.signinCallback}
   */
  async signinSilentCallback(e = window.location.href) {
    const t = this._logger.create("signinSilentCallback");
    await this._iframeNavigator.callback(e), t.info("success");
  }
  /**
   * Process any response (callback) from the authorization endpoint, by dispatching the request_type
   * and executing one of the following functions:
   * - {@link UserManager.signinRedirectCallback}
   * - {@link UserManager.signinPopupCallback}
   * - {@link UserManager.signinSilentCallback}
   *
   * @throws `Error` If request_type is unknown or signin cannot be processed.
   */
  async signinCallback(e = window.location.href) {
    const { state: t } = await this._client.readSigninResponseState(e);
    switch (t.request_type) {
      case "si:r":
        return await this.signinRedirectCallback(e);
      case "si:p":
        await this.signinPopupCallback(e);
        break;
      case "si:s":
        await this.signinSilentCallback(e);
        break;
      default:
        throw new Error("invalid response_type in state");
    }
  }
  /**
   * Process any response (callback) from the end session endpoint, by dispatching the request_type
   * and executing one of the following functions:
   * - {@link UserManager.signoutRedirectCallback}
   * - {@link UserManager.signoutPopupCallback}
   * - {@link UserManager.signoutSilentCallback}
   *
   * @throws `Error` If request_type is unknown or signout cannot be processed.
   */
  async signoutCallback(e = window.location.href, t = !1) {
    const { state: s } = await this._client.readSignoutResponseState(e);
    if (s)
      switch (s.request_type) {
        case "so:r":
          return await this.signoutRedirectCallback(e);
        case "so:p":
          await this.signoutPopupCallback(e, t);
          break;
        case "so:s":
          await this.signoutSilentCallback(e);
          break;
        default:
          throw new Error("invalid response_type in state");
      }
  }
  /**
   * Query OP for user's current signin status.
   *
   * @returns A promise object with session_state and subject identifier.
   */
  async querySessionStatus(e = {}) {
    const t = this._logger.create("querySessionStatus"), {
      silentRequestTimeoutInSeconds: s,
      ...i
    } = e, r = this.settings.silent_redirect_uri;
    r || t.throw(new Error("No silent_redirect_uri configured"));
    const n = await this._loadUser(), o = await this._iframeNavigator.prepare({ silentRequestTimeoutInSeconds: s }), c = await this._signinStart({
      request_type: "si:s",
      // this acts like a signin silent
      redirect_uri: r,
      prompt: "none",
      id_token_hint: this.settings.includeIdTokenInSilentRenew ? n == null ? void 0 : n.id_token : void 0,
      response_type: this.settings.query_status_response_type,
      scope: "openid",
      skipUserInfo: !0,
      ...i
    }, o);
    try {
      const l = {}, d = await this._client.processSigninResponse(c.url, l);
      return t.debug("got signin response"), d.session_state && d.profile.sub ? (t.info("success for subject", d.profile.sub), {
        session_state: d.session_state,
        sub: d.profile.sub
      }) : (t.info("success, user not authenticated"), null);
    } catch (l) {
      if (this.settings.monitorAnonymousSession && l instanceof B)
        switch (l.error) {
          case "login_required":
          case "consent_required":
          case "interaction_required":
          case "account_selection_required":
            return t.info("success for anonymous user"), {
              // eslint-disable-next-line @typescript-eslint/no-non-null-assertion
              session_state: l.session_state
            };
        }
      throw l;
    }
  }
  async _signin(e, t, s) {
    const i = await this._signinStart(e, t);
    return await this._signinEnd(i.url, s);
  }
  async _signinStart(e, t) {
    const s = this._logger.create("_signinStart");
    try {
      const i = await this._client.createSigninRequest(e);
      return s.debug("got signin request"), await t.navigate({
        url: i.url,
        state: i.state.id,
        response_mode: i.state.response_mode,
        scriptOrigin: this.settings.iframeScriptOrigin
      });
    } catch (i) {
      throw s.debug("error after preparing navigator, closing navigator window"), t.close(), i;
    }
  }
  async _signinEnd(e, t) {
    const s = this._logger.create("_signinEnd"), i = {}, r = await this._client.processSigninResponse(e, i);
    return s.debug("got signin response"), await this._buildUser(r, t);
  }
  async _buildUser(e, t) {
    const s = this._logger.create("_buildUser"), i = new fe(e);
    if (t) {
      if (t !== i.profile.sub)
        throw s.debug("current user does not match user returned from signin. sub from signin:", i.profile.sub), new B({ ...e, error: "login_required" });
      s.debug("current user matches user returned from signin");
    }
    return await this.storeUser(i), s.debug("user stored"), await this._events.load(i), i;
  }
  /**
   * Trigger a redirect of the current window to the end session endpoint.
   *
   * @returns A promise
   */
  async signoutRedirect(e = {}) {
    const t = this._logger.create("signoutRedirect"), {
      redirectMethod: s,
      ...i
    } = e, r = await this._redirectNavigator.prepare({ redirectMethod: s });
    await this._signoutStart({
      request_type: "so:r",
      post_logout_redirect_uri: this.settings.post_logout_redirect_uri,
      ...i
    }, r), t.info("success");
  }
  /**
   * Process response (callback) from the end session endpoint.
   * It is recommended to use {@link UserManager.signoutCallback} instead.
   *
   * @returns A promise containing signout response
   *
   * @see {@link UserManager.signoutCallback}
   */
  async signoutRedirectCallback(e = window.location.href) {
    const t = this._logger.create("signoutRedirectCallback"), s = await this._signoutEnd(e);
    return t.info("success"), s;
  }
  /**
   * Trigger a redirect of a popup window to the end session endpoint.
   *
   * @returns A promise
   */
  async signoutPopup(e = {}) {
    const t = this._logger.create("signoutPopup"), {
      popupWindowFeatures: s,
      popupWindowTarget: i,
      popupSignal: r,
      ...n
    } = e, o = this.settings.popup_post_logout_redirect_uri, c = await this._popupNavigator.prepare({ popupWindowFeatures: s, popupWindowTarget: i, popupSignal: r });
    await this._signout({
      request_type: "so:p",
      post_logout_redirect_uri: o,
      // we're putting a dummy entry in here because we
      // need a unique id from the state for notification
      // to the parent window, which is necessary if we
      // plan to return back to the client after signout
      // and so we can close the popup after signout
      state: o == null ? void 0 : {},
      ...n
    }, c), t.info("success");
  }
  /**
   * Process response (callback) from the end session endpoint from a popup window.
   * It is recommended to use {@link UserManager.signoutCallback} instead.
   *
   * @returns A promise
   *
   * @see {@link UserManager.signoutCallback}
   */
  async signoutPopupCallback(e = window.location.href, t = !1) {
    const s = this._logger.create("signoutPopupCallback");
    await this._popupNavigator.callback(e, { keepOpen: t }), s.info("success");
  }
  async _signout(e, t) {
    const s = await this._signoutStart(e, t);
    return await this._signoutEnd(s.url);
  }
  async _signoutStart(e = {}, t) {
    var s;
    const i = this._logger.create("_signoutStart");
    try {
      const r = await this._loadUser();
      i.debug("loaded current user from storage"), this.settings.revokeTokensOnSignout && await this._revokeInternal(r);
      const n = e.id_token_hint || r && r.id_token;
      n && (i.debug("setting id_token_hint in signout request"), e.id_token_hint = n), await this.removeUser(), i.debug("user removed, creating signout request");
      const o = await this._client.createSignoutRequest(e);
      return i.debug("got signout request"), await t.navigate({
        url: o.url,
        state: (s = o.state) == null ? void 0 : s.id,
        scriptOrigin: this.settings.iframeScriptOrigin
      });
    } catch (r) {
      throw i.debug("error after preparing navigator, closing navigator window"), t.close(), r;
    }
  }
  async _signoutEnd(e) {
    const t = this._logger.create("_signoutEnd"), s = await this._client.processSignoutResponse(e);
    return t.debug("got signout response"), s;
  }
  /**
   * Trigger a silent request (via an iframe) to the end session endpoint.
   *
   * @returns A promise
   */
  async signoutSilent(e = {}) {
    var t;
    const s = this._logger.create("signoutSilent"), {
      silentRequestTimeoutInSeconds: i,
      ...r
    } = e, n = this.settings.includeIdTokenInSilentSignout ? (t = await this._loadUser()) == null ? void 0 : t.id_token : void 0, o = this.settings.popup_post_logout_redirect_uri, c = await this._iframeNavigator.prepare({ silentRequestTimeoutInSeconds: i });
    await this._signout({
      request_type: "so:s",
      post_logout_redirect_uri: o,
      id_token_hint: n,
      ...r
    }, c), s.info("success");
  }
  /**
   * Notify the parent window of response (callback) from the end session endpoint.
   * It is recommended to use {@link UserManager.signoutCallback} instead.
   *
   * @returns A promise
   *
   * @see {@link UserManager.signoutCallback}
   */
  async signoutSilentCallback(e = window.location.href) {
    const t = this._logger.create("signoutSilentCallback");
    await this._iframeNavigator.callback(e), t.info("success");
  }
  async revokeTokens(e) {
    const t = await this._loadUser();
    await this._revokeInternal(t, e);
  }
  async _revokeInternal(e, t = this.settings.revokeTokenTypes) {
    const s = this._logger.create("_revokeInternal");
    if (!e) return;
    const i = t.filter((r) => typeof e[r] == "string");
    if (!i.length) {
      s.debug("no need to revoke due to no token(s)");
      return;
    }
    for (const r of i)
      await this._client.revokeToken(
        e[r],
        // eslint-disable-line @typescript-eslint/no-non-null-assertion
        r
      ), s.info(`${r} revoked successfully`), r !== "access_token" && (e[r] = null);
    await this.storeUser(e), s.debug("user stored"), await this._events.load(e);
  }
  /**
   * Enables silent renew for the `UserManager`.
   */
  startSilentRenew() {
    this._logger.create("startSilentRenew"), this._silentRenewService.start();
  }
  /**
   * Disables silent renew for the `UserManager`.
   */
  stopSilentRenew() {
    this._silentRenewService.stop();
  }
  get _userStoreKey() {
    return `user:${this.settings.authority}:${this.settings.client_id}`;
  }
  async _loadUser() {
    const e = this._logger.create("_loadUser"), t = await this.settings.userStore.get(this._userStoreKey);
    return t ? (e.debug("user storageString loaded"), fe.fromStorageString(t)) : (e.debug("no user storageString"), null);
  }
  async storeUser(e) {
    const t = this._logger.create("storeUser");
    if (e) {
      t.debug("storing user");
      const s = e.toStorageString();
      await this.settings.userStore.set(this._userStoreKey, s);
    } else
      this._logger.debug("removing user"), await this.settings.userStore.remove(this._userStoreKey), this.settings.dpop && await this.settings.dpop.store.remove(this.settings.client_id);
  }
  /**
   * Removes stale state entries in storage for incomplete authorize requests.
   */
  async clearStaleState() {
    await this._client.clearStaleState();
  }
  /**
   * Dynamically generates a DPoP proof for a given user, URL and optional Http method.
   * This method is useful when you need to make a request to a resource server
   * with fetch or similar, and you need to include a DPoP proof in a DPoP header.
   * @param url - The URL to generate the DPoP proof for
   * @param user - The user to generate the DPoP proof for
   * @param httpMethod - Optional, defaults to "GET"
   * @param nonce - Optional nonce provided by the resource server
   *
   * @returns A promise containing the DPoP proof or undefined if DPoP is not enabled/no user is found.
   */
  async dpopProof(e, t, s, i) {
    var r, n;
    const o = await ((n = (r = this.settings.dpop) == null ? void 0 : r.store) == null ? void 0 : n.get(this.settings.client_id));
    if (o)
      return await C.generateDPoPProof({
        url: e,
        accessToken: t == null ? void 0 : t.access_token,
        httpMethod: s,
        keyPair: o.keys,
        nonce: i
      });
  }
  async generateDPoPJkt(e) {
    let t = await e.store.get(this.settings.client_id);
    if (!t) {
      const s = await C.generateDPoPKeys();
      t = new tt(s), await e.store.set(this.settings.client_id, t);
    }
    return await C.generateDPoPJkt(t.keys);
  }
};
const Es = ["url", "clientId", "redirectUri", "scope", "logoutUrl"], Cs = "openid profile email";
function Ps(e, t) {
  const s = {};
  return e.forEach((i) => {
    t[i] !== void 0 && (s[i] = t[i]);
  }), s;
}
let p, V;
const Rs = (e) => (V = Ps(Es, e), new Is({
  authority: V.url,
  client_id: V.clientId,
  redirect_uri: V.redirectUri,
  response_type: "code",
  scope: V.scope || Cs,
  filterProtocolClaims: !0,
  includeIdTokenInSilentRenew: !0,
  includeIdTokenInSilentSignout: !0,
  loadUserInfo: !0
})), Us = async () => {
  try {
    console.debug("[Auth] Logging in using OIDC");
    const e = new URL(window.location.href), t = await (p == null ? void 0 : p.getUser());
    e.searchParams.get("state") || t ? await (p == null ? void 0 : p.signinRedirectCallback()) : await (p == null ? void 0 : p.signinRedirect().then(() => {
      p == null || p.startSilentRenew(), p == null || p.signinRedirectCallback();
    }).catch((s) => {
      console.log(s);
    }));
  } catch (e) {
    console.error("[Auth] Error logging in using OIDC: ", e);
  }
}, xs = async () => p == null ? void 0 : p.removeUser().then(() => p == null ? void 0 : p.signoutRedirect({
  post_logout_redirect_uri: V.logoutUrl || window.location.href
})), As = async () => await (p == null ? void 0 : p.getUser()) != null, Os = async () => {
  const e = await (p == null ? void 0 : p.getUser());
  return Promise.resolve(e == null ? void 0 : e.id_token);
}, Ns = async () => {
  const e = await (p == null ? void 0 : p.getUser());
  return Promise.resolve(e == null ? void 0 : e.profile.preferred_username);
};
let G, Z;
const qs = async (e, t) => {
  try {
    console.debug("[Auth] Setting Username and Password for BasicAuth"), G = e, Z = t;
  } catch (s) {
    console.error("[Auth] Error logging in using BasicAuth: ", s);
  }
}, Ds = async () => {
  console.debug("[Auth] Logout for BasicAuth"), G = void 0, Z = void 0, window.location.reload();
}, Ls = async () => G !== void 0 && Z !== void 0, js = async () => Promise.resolve(G), Hs = () => {
  if (G !== void 0 && Z != null)
    return {
      username: G,
      password: Z
    };
}, ct = () => {
  const e = ut(Jt);
  return e.type === "oidc" ? (p === void 0 && (console.debug("[Auth] Creating OIDC UserManager with options: ", e.options), p = Rs(e.options)), {
    isOidcAuthEnabled: () => !0,
    isBasicAuthEnabled: () => !1,
    isAuthenticated: As,
    getToken: Os,
    getUsernameAndPassword: () => {
    },
    getUsername: Ns,
    login: Us,
    logout: xs
  }) : e.type === "basic" ? {
    isOidcAuthEnabled: () => !1,
    isBasicAuthEnabled: () => !0,
    isAuthenticated: Ls,
    getToken: () => Promise.resolve(void 0),
    getUsernameAndPassword: Hs,
    getUsername: js,
    login: qs,
    logout: Ds
  } : {
    isOidcAuthEnabled: () => !1,
    isBasicAuthEnabled: () => !1,
    isAuthenticated: () => Promise.resolve(!1),
    getToken: () => Promise.resolve(void 0),
    getUsername: () => Promise.resolve(void 0),
    getUsernameAndPassword: () => {
    },
    login: () => Promise.resolve(),
    logout: () => Promise.resolve()
  };
}, Ie = (e) => {
  const [t, s] = k(""), [i, r] = k(""), [n, o] = k(), c = e.format || "locale";
  return Ce(() => {
    let l;
    if (e.date && typeof e.date == "string" ? l = se.fromISO(e.date) : e.date && typeof e.date == "object" && (l = se.fromJSDate(e.date)), l) {
      const d = {
        locale: e.locale
      };
      c === "fromNow" ? (s(l.toRelative() || ""), o(setInterval(() => {
        s(l.toRelative() || "");
      }, 5e3))) : s(c === "locale" ? l.toLocaleString(se.DATETIME_FULL, d) : l.toFormat(c, d)), r(l.toLocaleString(se.DATETIME_FULL, d));
    }
    return () => {
      n !== void 0 && clearInterval(n);
    };
  }, [e.date]), c === "fromNow" ? /* @__PURE__ */ a(_t, { content: /* @__PURE__ */ a("span", { children: i }), children: /* @__PURE__ */ a("span", { children: t }) }) : /* @__PURE__ */ a("span", { children: t });
}, Xs = (e) => /* @__PURE__ */ a(Ie, { date: e.date, format: "fromNow" }), O = ({ condition: e, children: t }) => (typeof e == "boolean" ? e : e()) ? /* @__PURE__ */ a($.Fragment, { children: t }) : /* @__PURE__ */ a($.Fragment, {}), Ys = ({ collection: e, emptyState: t, emptyStateTitle: s, emptyStateMessage: i, children: r }) => {
  const n = () => !e || e.length === 0, o = t || /* @__PURE__ */ v(ne, { variant: pt.xs, children: [
    /* @__PURE__ */ a(oe, { titleText: s || "None found", headingLevel: "h4" }),
    /* @__PURE__ */ a(me, { children: i || "No items found." })
  ] });
  return n() ? /* @__PURE__ */ a($.Fragment, { children: o }) : /* @__PURE__ */ a($.Fragment, { children: r });
}, ue = ({ isLoading: e, loadingComponent: t, children: s }) => {
  const i = () => typeof e == "boolean" ? e : e(), r = t || /* @__PURE__ */ a(ee, {});
  return i() ? /* @__PURE__ */ a($.Fragment, { children: r }) : /* @__PURE__ */ a($.Fragment, { children: s });
}, Zs = ({ toolbar: e, alwaysShowToolbar: t, emptyState: s, filteredEmptyState: i, isLoading: r, isError: n, loadingComponent: o, errorComponent: c, isEmpty: l, isFiltered: d, children: h }) => {
  const g = t || !l || d || n;
  return c || (c = /* @__PURE__ */ a("div", { style: { padding: "15px", backgroundColor: "white" }, children: /* @__PURE__ */ a(ft, { isInline: !0, variant: "danger", title: "Error: Something went wrong!", children: /* @__PURE__ */ a("p", { children: "Something went wrong with the action you attempted, but we're not sure what it was. Try reloading the page and hopef for a better result, or contact your admin to report the error." }) }) })), /* @__PURE__ */ v($.Fragment, { children: [
    /* @__PURE__ */ a(O, { condition: g, children: e }),
    /* @__PURE__ */ v(ue, { isLoading: r, loadingComponent: o, children: [
      /* @__PURE__ */ a(O, { condition: !l && !n, children: h }),
      /* @__PURE__ */ a(O, { condition: l && d && !n, children: i }),
      /* @__PURE__ */ a(O, { condition: l && !d && !n, children: s }),
      /* @__PURE__ */ a(O, { condition: n, children: c })
    ] })
  ] });
}, ei = (e) => {
  const [t, s] = k(!1), i = (l, d) => {
    s(!1);
    const h = d;
    h !== void 0 && h >= 0 ? e.onSelect(e.items[h]) : e.onSelect(void 0);
  }, r = () => {
    s(!t);
  }, n = (l) => {
    let d;
    return e.itemToTestId !== void 0 && (d = e.itemToTestId(l)), d;
  }, o = e.popperProps || {
    appendTo: e.menuAppendTo
  };
  let c = /* @__PURE__ */ a(Ot, { title: e.label });
  return e.isKebab || (c = /* @__PURE__ */ a($.Fragment, { children: e.label })), /* @__PURE__ */ a(
    mt,
    {
      isOpen: t,
      onSelect: i,
      onOpenChange: (l) => s(l),
      toggle: (l) => /* @__PURE__ */ a(
        Je,
        {
          "data-testid": e.testId,
          ref: l,
          onClick: r,
          isExpanded: t,
          variant: e.isKebab ? "plain" : "default",
          children: c
        }
      ),
      ouiaId: "ObjectDropdown",
      popperProps: o,
      shouldFocusToggleOnSelect: !0,
      children: /* @__PURE__ */ a(wt, { children: e.items.map((l, d) => e.itemIsVisible !== void 0 && !e.itemIsVisible(l) ? /* @__PURE__ */ a(Re, {}) : e.itemIsDivider && e.itemIsDivider(l) ? /* @__PURE__ */ a(Ke, { component: "li" }, `divider-${d}`) : /* @__PURE__ */ a(
        vt,
        {
          value: d,
          isDisabled: e.itemIsDisabled === void 0 ? !1 : e.itemIsDisabled(l),
          component: (h) => /* @__PURE__ */ a("button", { ...h, "data-testid": n(l) }),
          children: e.itemToString(l)
        },
        `action-${d}`
      )) })
    }
  );
}, $s = (e) => {
  var l;
  const [t, s] = k(!1), i = (d, h) => {
    s(!1), e.onSelect(e.items[h]);
  }, r = () => {
    s(!t);
  }, n = (d) => {
    let h;
    return e.itemToTestId !== void 0 && (h = e.itemToTestId(d)), h;
  }, o = (d) => /* @__PURE__ */ a(
    Je,
    {
      ref: d,
      className: e.toggleClassname || "menu-toggle",
      onClick: r,
      "data-testid": e.testId,
      isExpanded: t,
      children: e.value ? e.itemToString(e.value) : e.noSelectionLabel
    }
  ), c = {
    appendTo: e.appendTo === "document" ? () => document.body : "inline"
  };
  return /* @__PURE__ */ a(
    St,
    {
      toggle: o,
      id: e.toggleId,
      onSelect: i,
      onOpenChange: s,
      isOpen: t,
      popperProps: c,
      children: (l = e.items) == null ? void 0 : l.map((d, h) => e.itemIsDivider && e.itemIsDivider(d) ? /* @__PURE__ */ a(Ke, {}, h) : /* @__PURE__ */ a(
        yt,
        {
          isSelected: d === e.value,
          component: (g) => /* @__PURE__ */ a("button", { ...g, "data-testid": n(d) }),
          value: h,
          children: e.itemToString(d)
        },
        h
      ))
    }
  );
}, ti = ({ expanded: e, onClick: t }) => e ? /* @__PURE__ */ a(Nt, { onClick: t, style: { cursor: "pointer" } }) : /* @__PURE__ */ a(qt, { onClick: t, style: { cursor: "pointer" } }), lt = {
  padding: "5px",
  minHeight: "128px",
  borderRight: 0,
  borderLeft: 0,
  borderBottom: "1px solid #666",
  backgroundColor: "rgb(240, 240, 240)"
}, Ms = {
  ...lt,
  color: "red",
  overflow: "auto"
}, si = (e) => {
  const [t, s] = k(""), [i, r] = k(""), [n, o] = k(!1), [c, l] = k(), d = (T, A) => {
    s(A);
  }, h = () => t != null && t.trim().length > 0, g = () => c != null && c.trim().length > 0, _ = () => {
    o(!0), e.onUrlFetch(t).then((T) => {
      l(void 0), r(T), o(!1), e.onChange(T, t);
    }).catch((T) => {
      l(T.message), o(!1);
    });
  }, S = () => {
    s(""), r(""), e.onChange(void 0, void 0);
  }, x = /* @__PURE__ */ v("div", { className: "url-upload-loading", style: lt, children: [
    /* @__PURE__ */ a(ee, { size: "md", className: "spinner", style: { marginRight: "5px" } }),
    /* @__PURE__ */ a("span", { className: "spinner-message", children: "Loading URL content" })
  ] });
  return /* @__PURE__ */ v("div", { className: "url-upload", "data-testid": e.testId, children: [
    /* @__PURE__ */ v("div", { className: "url-upload-flex", style: { display: "flex" }, children: [
      /* @__PURE__ */ a("div", { className: "url-upload-url", style: { flexGrow: 1 }, children: /* @__PURE__ */ a(
        ae,
        {
          "data-testid": `${e.testId}-input`,
          value: t,
          type: "text",
          placeholder: e.urlPlaceholder,
          id: e.id,
          onChange: d,
          "aria-label": "url input"
        }
      ) }),
      /* @__PURE__ */ a("div", { className: "url-fetch-button", children: /* @__PURE__ */ a(ce, { "data-testid": `${e.testId}-fetch`, variant: "control", isDisabled: !h(), onClick: _, children: "Fetch" }) }),
      /* @__PURE__ */ a("div", { className: "url-clear-button", children: /* @__PURE__ */ a(ce, { "data-testid": `${e.testId}-clear`, variant: "control", isDisabled: !h(), onClick: S, children: "Clear" }) })
    ] }),
    /* @__PURE__ */ a("div", { className: "url-upload-preview", children: /* @__PURE__ */ v(ue, { isLoading: n, loadingComponent: x, children: [
      /* @__PURE__ */ a(O, { condition: g, children: /* @__PURE__ */ v("div", { className: "url-upload-error", style: Ms, children: [
        /* @__PURE__ */ a("div", { children: "Error getting content from URL." }),
        /* @__PURE__ */ a("div", { children: c })
      ] }) }),
      /* @__PURE__ */ a(O, { condition: !g(), children: /* @__PURE__ */ a(
        bt,
        {
          "data-testid": `${e.testId}-preview`,
          "aria-label": "url-content",
          value: i,
          readOnly: !0,
          style: { minHeight: "128px" }
        }
      ) })
    ] }) })
  ] });
}, ii = (e) => {
  const [t, s] = k(), [i, r] = k();
  return Ce(() => {
    e.isOpen && (typeof e.frontendInfo == "function" ? e.frontendInfo().then(s) : s(e.frontendInfo), typeof e.backendInfo == "function" ? e.backendInfo().then(r) : r(e.backendInfo));
  }, [e.isOpen]), /* @__PURE__ */ a(
    kt,
    {
      className: "app-about-modal",
      isOpen: e.isOpen,
      onClose: e.onClose,
      trademark: "© 2024 Red Hat",
      brandImageSrc: e.brandImageSrc,
      brandImageAlt: e.brandImageAlt,
      "aria-label": e.brandImageAlt,
      children: /* @__PURE__ */ v(Tt, { className: "app-about-modal-content", style: { marginTop: "-25px" }, children: [
        /* @__PURE__ */ a(De, { component: Le.h2, children: "Web console info" }),
        /* @__PURE__ */ a(ue, { isLoading: t === void 0, children: /* @__PURE__ */ v(je, { component: "dl", children: [
          /* @__PURE__ */ a(b, { component: "dt", children: "Project" }),
          /* @__PURE__ */ a(b, { component: "dd", children: /* @__PURE__ */ a("a", { href: t == null ? void 0 : t.url, target: "_blank", children: t == null ? void 0 : t.name }) }),
          /* @__PURE__ */ a(b, { component: "dt", children: "Version" }),
          /* @__PURE__ */ a(b, { component: "dd", children: t == null ? void 0 : t.version }),
          /* @__PURE__ */ a(b, { component: "dt", children: "Built on" }),
          /* @__PURE__ */ a(b, { component: "dd", children: /* @__PURE__ */ a(Ie, { date: t == null ? void 0 : t.builtOn, format: "locale" }) }),
          /* @__PURE__ */ a(b, { component: "dt", children: "Digest" }),
          /* @__PURE__ */ a(b, { component: "dd", children: t == null ? void 0 : t.digest })
        ] }) }),
        /* @__PURE__ */ a(De, { style: { marginTop: "40px" }, component: Le.h2, children: e.backendLabel }),
        /* @__PURE__ */ a(ue, { isLoading: i === void 0, children: /* @__PURE__ */ v(je, { component: "dl", children: [
          /* @__PURE__ */ a(b, { component: "dt", children: "Name" }),
          /* @__PURE__ */ a(b, { component: "dd", children: (i == null ? void 0 : i.name) || "" }),
          /* @__PURE__ */ a(b, { component: "dt", children: "Description" }),
          /* @__PURE__ */ a(b, { component: "dd", children: (i == null ? void 0 : i.description) || "" }),
          /* @__PURE__ */ a(b, { component: "dt", children: "Version" }),
          /* @__PURE__ */ a(b, { component: "dd", children: (i == null ? void 0 : i.version) || "" }),
          /* @__PURE__ */ a(b, { component: "dt", children: "Built on" }),
          /* @__PURE__ */ a(b, { component: "dd", children: /* @__PURE__ */ a(Ie, { date: i == null ? void 0 : i.builtOn, format: "locale" }) })
        ] }) })
      ] })
    }
  );
}, Fs = (e) => {
  const [t, s] = k({
    username: "",
    password: ""
  }), i = () => {
    e.onLogin(t);
  }, r = (o, c) => {
    s({
      ...t,
      username: c
    });
  }, n = (o, c) => {
    s({
      ...t,
      password: c
    });
  };
  return /* @__PURE__ */ a(
    Ue,
    {
      title: "Login",
      variant: "small",
      isOpen: !0,
      header: /* @__PURE__ */ a("a", { href: "#" }),
      showClose: !1,
      className: "please-wait pf-m-redhat-font",
      "aria-label": "please-wait-modal",
      style: { marginTop: "-15px" },
      actions: [
        /* @__PURE__ */ a(ce, { variant: "primary", "data-testid": "modal-btn-login", onClick: i, isDisabled: (t == null ? void 0 : t.username) === "" || (t == null ? void 0 : t.password) === "", children: "Login" }, "login")
      ],
      children: /* @__PURE__ */ v(Be, { children: [
        /* @__PURE__ */ a(
          He,
          {
            label: "Username",
            fieldId: "form-username",
            children: /* @__PURE__ */ a(
              ae,
              {
                isRequired: !0,
                type: "text",
                id: "form-username",
                "data-testid": "basic-auth-login-modal-username",
                name: "form-username",
                value: t == null ? void 0 : t.username,
                placeholder: "Username",
                onChange: r
              }
            )
          }
        ),
        /* @__PURE__ */ a(
          He,
          {
            label: "Password",
            fieldId: "form-password",
            children: /* @__PURE__ */ a(
              ae,
              {
                isRequired: !0,
                type: "text",
                id: "form-password",
                "data-testid": "basic-auth-login-modal-password",
                name: "form-password",
                value: t == null ? void 0 : t.password,
                placeholder: "Password",
                onChange: n
              }
            )
          }
        )
      ] })
    }
  );
}, ri = (e) => /* @__PURE__ */ v(
  Ue,
  {
    title: "Please Wait",
    variant: "small",
    isOpen: e.isOpen,
    header: /* @__PURE__ */ a("a", { href: "#" }),
    showClose: !1,
    className: "please-wait pf-m-redhat-font",
    "aria-label": "please-wait-modal",
    style: { marginTop: "-15px" },
    children: [
      /* @__PURE__ */ a(ee, { size: "md", className: "spinner" }),
      /* @__PURE__ */ a("span", { className: "message", style: { fontSize: "15px", color: "#333", marginLeft: "10px" }, children: e.message })
    ]
  }
), ni = (e) => /* @__PURE__ */ a(
  Ue,
  {
    title: e.title,
    variant: "small",
    isOpen: e.isOpen,
    showClose: e.isCloseable,
    onClose: e.onClose,
    className: "progress pf-m-redhat-font",
    "aria-label": "progress-modal",
    children: /* @__PURE__ */ a(It, { title: e.message, value: e.progress })
  }
), oi = (e) => {
  const [t, s] = k(
    0
    /* AUTHENTICATING */
  ), i = ct(), r = (n) => {
    console.info("[ApplicationAuth] Using username and password."), i.login(n.username, n.password), s(
      1
      /* AUTHENTICATED */
    );
  };
  return Ce(() => {
    i.isOidcAuthEnabled() ? i.login("", "").then(() => {
      console.info("[ApplicationAuth] Authentication successful."), s(
        1
        /* AUTHENTICATED */
      );
    }).catch((n) => {
      console.error("[ApplicationAuth] Authentication failed: ", n), s(
        2
        /* AUTHENTICATION_FAILED */
      );
    }) : i.isBasicAuthEnabled() || s(
      1
      /* AUTHENTICATED */
    );
  }, []), /* @__PURE__ */ v(Re, { children: [
    /* @__PURE__ */ a(O, { condition: t === 0 && i.isOidcAuthEnabled(), children: /* @__PURE__ */ v(ne, { children: [
      /* @__PURE__ */ a(oe, { titleText: "Loading", headingLevel: "h4" }),
      /* @__PURE__ */ a(me, { children: /* @__PURE__ */ a(ee, { size: "xl", "aria-label": "Loading spinner" }) })
    ] }) }),
    /* @__PURE__ */ a(O, { condition: t === 0 && i.isBasicAuthEnabled(), children: /* @__PURE__ */ a(Fs, { onLogin: r }) }),
    /* @__PURE__ */ a(O, { condition: t === 2, children: /* @__PURE__ */ v(ne, { children: [
      /* @__PURE__ */ a(oe, { titleText: "Empty state", headingLevel: "h4", icon: /* @__PURE__ */ a(ze, { icon: Dt }) }),
      /* @__PURE__ */ a(me, { children: "Authentication failed." })
    ] }) }),
    /* @__PURE__ */ a(O, { condition: t === 1, children: e.children })
  ] });
}, ai = (e) => {
  const t = ct();
  return (() => {
    let i = !0;
    return e.enabled !== void 0 && (i = i && (t.isOidcAuthEnabled() === e.enabled || t.isBasicAuthEnabled() === e.enabled)), i;
  })() ? /* @__PURE__ */ a($.Fragment, { children: e.children }) : /* @__PURE__ */ a($.Fragment, {});
}, ci = (e) => /* @__PURE__ */ a(Et, { categoryName: e.categoryName || "Filters", isClosable: !0, onClick: e.onClearAllCriteria, children: e.criteria.map((t, s) => /* @__PURE__ */ v(Ct, { onClick: () => e.onRemoveCriteria(t), children: [
  /* @__PURE__ */ a("b", { children: t.filterBy.label }),
  /* @__PURE__ */ a("span", { children: ": " }),
  /* @__PURE__ */ a("span", { children: t.filterValue })
] }, s)) }), li = (e) => {
  const [t, s] = k(e.filterTypes[0]), [i, r] = k(""), n = (o) => {
    o && o.preventDefault(), e.onAddCriteria({
      filterBy: t,
      filterValue: i
    }), r("");
  };
  return /* @__PURE__ */ a(Be, { onSubmit: n, children: /* @__PURE__ */ v(Pt, { children: [
    /* @__PURE__ */ a(
      $s,
      {
        value: t,
        items: e.filterTypes,
        testId: "chip-filter-select",
        toggleClassname: "chip-filter-toggle",
        onSelect: s,
        itemToTestId: (o) => o.testId,
        itemToString: (o) => o.label
      }
    ),
    /* @__PURE__ */ a(
      ae,
      {
        name: "filterValue",
        id: "filterValue",
        type: "search",
        value: i,
        onChange: (o, c) => r(c),
        "data-testid": "chip-filter-value",
        "aria-label": "search input"
      }
    ),
    /* @__PURE__ */ a(
      ce,
      {
        variant: Rt.control,
        onClick: n,
        "data-testid": "chip-filter-search",
        "aria-label": "search button for search input",
        children: /* @__PURE__ */ a(Lt, {})
      }
    )
  ] }) });
};
function di() {
  return /* @__PURE__ */ a(ne, { children: /* @__PURE__ */ a(
    oe,
    {
      titleText: "Loading",
      headingLevel: "h4",
      icon: /* @__PURE__ */ a(ze, { icon: ee })
    }
  ) });
}
function hi({
  itemCount: e,
  page: t,
  perPage: s,
  isCompact: i = !1,
  onChange: r,
  variant: n = xt.top
}) {
  return /* @__PURE__ */ a(
    Ut,
    {
      itemCount: e,
      page: t,
      perPage: s,
      onSetPage: (o, c) => r(c, s),
      onPerPageSelect: (o, c) => r(1, c),
      variant: n,
      isCompact: i
    }
  );
}
function Ws({ columns: e, rows: t, getTd: s = () => xe }) {
  const i = new Array(e).fill(0).map((n, o) => {
    const c = s(o);
    return /* @__PURE__ */ a(c, { children: /* @__PURE__ */ a(
      At,
      {
        screenreaderText: o === 0 ? "Loading data" : void 0
      }
    ) }, `cell_${o}`);
  }), r = new Array(t).fill(0).map((n, o) => /* @__PURE__ */ a(le, { children: i }, `row_${o}`));
  return /* @__PURE__ */ a(Re, { children: r });
}
const gi = ({
  ariaLabel: e,
  minimumColumnWidth: t = 250,
  columns: s,
  data: i,
  renderHeader: r,
  renderCell: n,
  renderActions: o,
  isColumnSortable: c,
  isRowDeleted: l,
  isRowSelected: d,
  expectedLength: h = 3,
  onRowClick: g,
  setActionCellOuiaId: _,
  setRowOuiaId: S,
  tableOuiaId: x,
  children: T,
  variant: A
}) => {
  const [I, N] = k(1e3);
  let P;
  const M = ({ width: f }) => {
    P && cancelAnimationFrame(P), f && (P = requestAnimationFrame(() => {
      N(f);
    }));
  }, { ref: R } = Wt({ onResize: M }), m = I >= 576, E = Ne(
    (f) => m && f !== 0 && f !== s.length - 1,
    [s, m]
  ), U = qe(() => s.map((f, w) => {
    const q = re(
      ({ children: J, ...K }, Q) => /* @__PURE__ */ a(
        dt,
        {
          position: w,
          tableWidth: I,
          columnWidth: t,
          canHide: E(w),
          sort: c ? c(f) : void 0,
          ...K,
          ref: Q,
          children: J
        }
      )
    );
    return q.displayName = "ResponsiveThCurried", r({
      Th: q,
      key: `header_${f}`,
      column: f,
      colIndex: w
    });
  }), [
    E,
    s,
    c,
    t,
    r,
    I
  ]), y = Ne(
    (f) => {
      const w = re(
        ({ children: q, ...J }, K) => /* @__PURE__ */ a(
          Ee,
          {
            position: f,
            tableWidth: I,
            columnWidth: t,
            canHide: E(f),
            ...J,
            ref: K,
            children: q
          }
        )
      );
      return w.displayName = "ResponsiveTdCurried", w;
    },
    [E, t, I]
  ), z = qe(
    () => s.map((f, w) => y(w)),
    [s, y]
  );
  return /* @__PURE__ */ v(
    Ht,
    {
      "aria-label": e,
      gridBreakPoint: "",
      ref: R,
      className: m ? "" : "pf-m-grid",
      ouiaId: x,
      variant: A,
      children: [
        /* @__PURE__ */ a($t, { children: /* @__PURE__ */ a(le, { children: U }) }),
        /* @__PURE__ */ v(Mt, { children: [
          i === void 0 && /* @__PURE__ */ a(
            Ws,
            {
              columns: s.length,
              rows: h,
              getTd: y
            }
          ),
          i == null ? void 0 : i.map((f, w) => {
            const q = l !== void 0 && l({ row: f, rowIndex: w }), J = d !== void 0 && d({ row: f, rowIndex: w }), K = !q && g ? () => g({ row: f, rowIndex: w }) : void 0, Q = s.map((X, te) => n({
              Td: z[te],
              key: `row_${w}_cell_${X}`,
              column: X,
              colIndex: te,
              rowIndex: w,
              row: f
            })), _e = !q && o && /* @__PURE__ */ a(
              Ee,
              {
                position: s.length,
                tableWidth: I,
                columnWidth: t,
                canHide: !1,
                isActionCell: !0,
                "data-testid": _ ? _({ row: f, rowIndex: w }) : `actions-for-row-${w}`,
                children: o({ rowIndex: w, row: f, ActionsColumn: Ft })
              }
            );
            return /* @__PURE__ */ v(
              ht,
              {
                isDeleted: q,
                isSelected: J,
                onClick: K,
                rowOuiaId: S == null ? void 0 : S({ row: f, rowIndex: w }),
                children: [
                  Q,
                  _e
                ]
              },
              `row_${w}`
            );
          }),
          (i == null ? void 0 : i.length) === 0 && /* @__PURE__ */ a(le, { children: /* @__PURE__ */ a(xe, { colSpan: s.length, children: T }) })
        ] })
      ]
    }
  );
}, dt = Pe(
  re((e, t) => {
    const {
      tableWidth: s,
      columnWidth: i,
      position: r,
      canHide: n,
      className: o = "",
      children: c,
      ...l
    } = e, d = n && s < i * (r + 1) ? "pf-m-hidden" : "pf-m-visible";
    return /* @__PURE__ */ a(
      jt,
      {
        ref: t,
        className: `${d} ${o}`,
        ...l,
        children: c
      }
    );
  })
);
dt.displayName = "ResponsiveTh";
const Ee = Pe(
  re((e, t) => {
    const {
      tableWidth: s,
      columnWidth: i,
      position: r,
      canHide: n,
      className: o = "",
      children: c,
      ...l
    } = e, d = n && s < i * (r + 1) ? "pf-m-hidden" : "pf-m-visible";
    return /* @__PURE__ */ a(
      xe,
      {
        ref: t,
        className: `${d} ${o}`,
        ...l,
        children: c
      }
    );
  })
);
Ee.displayName = "ResponsiveTd";
const ht = Pe(
  ({ isDeleted: e, isSelected: t, onClick: s, children: i, rowOuiaId: r }) => /* @__PURE__ */ a(
    le,
    {
      onRowClick: (n) => {
        (n == null ? void 0 : n.target) instanceof HTMLElement && (["a", "button"].includes(n.target.tagName.toLowerCase()) || s && s());
      },
      ouiaId: r,
      isRowSelected: t,
      className: e ? "mas--ResponsiveTable__Tr--deleted" : void 0,
      "data-testid": [t && "row-selected", e && "row-deleted"].filter((n) => !!n).join(" "),
      role: "row",
      children: i
    }
  )
);
ht.displayName = "DeletableRow";
export {
  ii as AppAboutModal,
  oi as ApplicationAuth,
  Jt as AuthConfigContext,
  Fs as BasicAuthModal,
  li as ChipFilterInput,
  Ie as DateTime,
  ht as DeletableRow,
  ci as FilterChips,
  Xs as FromNow,
  O as If,
  ai as IfAuth,
  Ys as IfNotEmpty,
  ue as IfNotLoading,
  Zs as ListWithToolbar,
  di as Loading,
  ei as ObjectDropdown,
  $s as ObjectSelect,
  hi as Pagination,
  ri as PleaseWaitModal,
  ni as ProgressModal,
  gi as ResponsiveTable,
  Ee as ResponsiveTd,
  dt as ResponsiveTh,
  Ws as TableSkeleton,
  ti as ToggleIcon,
  si as UrlUpload,
  ct as useAuth
};
